#
#  Copyright (C) 2009 GSyC/LibreSoft
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
#    Author : Jose Antonio Santos Cadenas <jcaden __at__ gsyc __dot__ es>
#


from django.conf.urls.defaults import *
from django.views.generic.simple import direct_to_template
from social.rest.forms import PhotoForm

# Uncomment the next two lines to enable the admin:
# from django.contrib import admin
# admin.autodiscover()

urlpatterns = patterns('',
    # Example:
    # (r'^pinax_sn_rest/', include('pinax_sn_rest.foo.urls')),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs' 
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
    # (r'^admin/(.*)', admin.site.root),
#    (r'^$', 'pinax_sn.views.main'),
    #url(r'^$', direct_to_template, {"template": "social_test.html",} , name="test"),
    url(r'^$', direct_to_template, {"template": "social_test.html", "extra_context":{"photo_form": PhotoForm()} } , name="test"),
    url(r'^node/(?P<node>[1-9][0-9]*)/near_nodes/$', 'social.rest.views.node_near', name="node_near"),
    url(r'^node/(?P<node_id>[1-9][0-9]*)/data/$', 'social.rest.views.node_data', name="node_data"),
    url(r'^node/(?P<node_id>[1-9][0-9]*)/position_update/$', 'social.rest.views.node_set_position', name="node_set_position"),
    url(r'^node/list/$', 'social.rest.views.node_list', name="node_list"),
    url(r'^note/create/$', 'social.rest.views.create_note', name="create_note"),
    url(r'^note/list/$', 'social.rest.views.note_list', name="note_list"),
    url(r'^note/(?P<note_id>[1-9][0-9]*)/data/$', 'social.rest.views.note_data', name="note_data"),
    url(r'^user/login/$', 'social.rest.views.user_login', name="user_login"),
    url(r'^user/create/$', 'social.rest.views.user_create', name="user_create"),
    url(r'^user/(?P<user>[1-9][0-9]*)/position/$', 'social.rest.views.user_position', name="user_pos"),
    url(r'^user/(?P<user>[1-9][0-9]*)/data/$', 'social.rest.views.user_data', name="user_data"),
    url(r'^user/my_data/$', 'social.rest.views.user_my_data', name="user_my_data"),
    url(r'^user/(?P<user>[1-9][0-9]*)/friends/$', 'social.rest.views.user_friends', name="user_friends"),
    url(r'^user/(?P<user>[1-9][0-9]*)/near_people/$', 'social.rest.views.user_near', name="user_near"),
    url(r'^user/(?P<user>[1-9][0-9]*)/near_friends/$', 'social.rest.views.user_near_friends', name="user_near_friends"),
    url(r'^user/(?P<user>[1-9][0-9]*)/set_status/$', 'social.rest.views.user_set_status', name="user_set_status"),
    url(r'^user/list/$', 'social.rest.views.user_all', name="user_all"),
    url(r'^user/delete/$', 'social.rest.views.user_delete', name="user_delete"),
    url(r'^user/relation/$', 'social.rest.views.user_relation', name="user_relation"),
    url(r'^user/relation/delete/$', 'social.rest.views.user_relation_delete', name="user_relation_delete"),
    url(r'^group/create/$', 'social.rest.views.group_create', name="group_create"),
    url(r'^group/list/$', 'social.rest.views.group_list', name="group_list"),
    url(r'^group/(?P<group>[1-9][0-9]*)/data/$', 'social.rest.views.group_data', name="group_data"),
    url(r'^group/delete/$', 'social.rest.views.group_delete', name="group_delete"),
    url(r'^group/join/$', 'social.rest.views.group_join', name="group_join"),
    url(r'^group/join/delete/$', 'social.rest.views.group_join_delete', name="group_unjoin"),
    url(r'^photo/upload/$', 'social.rest.views.photo_upload', name="photo_upload"),
    url(r'^photo/list/$', 'social.rest.views.photo_list', name="photo_list"),
    url(r'^photo/(?P<photo_id>[1-9][0-9]*)/data/$', 'social.rest.views.photo_data', name="photo_data"),
    url(r'^photo/(?P<photo_id>[1-9][0-9]*)/image/$', 'social.rest.views.photo_image', name="photo_image"),
    #url(r'^group/add/photo/$', 'social.rest.views.add_photo', name="group_add_photo"),
)
