#!/usr/bin/env python

#  Copyright (C) 2009 GSyC/LibreSoft
# 
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see http://www.gnu.org/licenses/.
#
#  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
#
#

from Items.PlaceItem import *

from GenericChannel import *

from urllib2 import urlopen
from xml.dom.minidom import parseString


class C_11870Channel (GenericChannel):

	url_api = "http://11870.com/api/v1/search?lat=%s&lon=%s&radius=%s&authSign=3572a8bb3f7dc6c9b2b80907beff2f5f&appToken=74805753bf8cef647b46101266370e05&q=%s"

	def __init__ (self, place):
		self.places_list = []
	
	def set_config (self, pattern, latitude, longitude, radius):
		
		self.set_search_pattern (pattern)
		self.latitude = latitude
		self.longitude = longitude
		self.radius = radius


	def process (self):

		url_11870 = self.url_api % (self.latitude, self.longitude,
									self.radius, self.search_pattern)

		print url_11870
		r = urlopen(url_11870)
		string_data = r.read()
		dom = parseString(string_data)
		feed = dom.firstChild
		resp = feed.toxml();
		
		for item in feed.getElementsByTagName("entry"):

			place = PlaceItem()

			place.service = "11870"
			place.title = self.getInnerText(item, "title")
			place.summary = self.getInnerText(item, "summary")
			place.url = self.getInnerText(item, "id")
			place.address = self.getInnerText(item, "oos:useraddress")
			place.phone = self.getInnerText(item, "oos:telephone")
			place.city = self.getInnerText(item, "oos:locality")
			place.region = self.getInnerText(item, "oos:subadministrativearea")
			place.country = self.getInnerText(item, "oos:country")

			pos = self.getInnerText(item, "gml:pos")
			place.latitude = pos.split(' ')[0]
			place.longitude = pos.split(' ')[1] 

			print place.title + " - " + place.service

			self.places_list.append (place)

			
	def getInnerText (self, domNode, tag=None):
		try:
			if tag ==None:
				return domNode.childNodes[0].nodeValue
			else:
				return domNode.getElementsByTagName(tag)[0].childNodes[0].nodeValue
		except:
			return None
			
