#!/usr/bin/env python

# Copyright (C) 2009 GSyC/LibreSoft
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Authors : Roberto Calvo <rocapal@gsyc.es>


import sys

"""
This class implements the generic data of Item.
 - id: system identifier <int>
 - title: title of resource <string>
 - summary: description of resource <string>
 - date: creation data in the system <date>
 - latitude:  <double>
 - longitude: <double>
 - radius: <double>
 - url: item url <string>
 - service: name of service (ej: 11870, panoramio) <string>
 - keywords: list of keys <list(string)>

"""

class GenericItem:
	

	def __init__ (self):
		
		self.id = None
		self.title = None
		self.summary = None
		self.date = None
		
		self.latitude = None
		self.longitude = None
		self.radius = None

		self.service = None
		self.keywords = None

