#
#  Copyright (C) 2009 GSyC/LibreSoft
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>._
# 
#    Author : Jorge Fernandez Gonzalez <jorge.fernandez.gonzalez __at__ gmail.com>
#

from apps.gymkhana.models import *

def create(title, place, celebration, welcome_text, goodbye_text, manager_id):
    new_event = Event()
    new_event.title = title
    new_event.place = place
    new_event.celebration = celebration
    new_event.welcome_text = welcome_text
    new_event.goodbye_text = goodbye_text
    new_event.save()

    user = Person.objects.get(id=manager_id)
    manager = Manager.objects.get(user=user)
    manager.events.add(new_event)
    manager.save()

    return True, new_event

def show(event):
    proofs = event.proof_set.all().order_by('number')
    teams = event.team_set.all()
    first_proofs = FirstProof.objects.filter(event=event)
    try:
      manager = Manager.objects.get(events__id=event.id)
    except:
      manager = None

    return True, proofs, teams, first_proofs, manager

def delete(event):
    proofs = event.proof_set.all().order_by('number')
    if len(proofs) > 0:
      for proof in proofs:
        possible_solutions = proof.solution_set.all()
        for possible_solution in possible_solutions:
          possible_solution.delete()
        responses = proof.response_set.all()
        for response in responses:
          response.delete()
        proof.delete()

    teams = event.team_set.all()
    if len(teams) > 0:
      for team in teams:
        team_members = team.teammember_set.all()
        if len(team_members) > 0:
          for team_member in team_members:
            team_member.delete()
        responses = team.responses.all()
        for response in responses:
          if response.proof.event == event:
            response.delete()
        acquired_clues = AcquiredClue.objects.filter(team=team)
        for acquired_clue in acquired_clues:
          if acquired_clue.clue.proof.event == event:
            acquired_clue.delete()

    event.delete()
    return True, "No Error"

def list_all():
    return True, Event.objects.all()
