#
#  Copyright (C) 2009 GSyC/LibreSoft
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>._
# 
#    Author : Jorge Fernandez Gonzalez <jorge.fernandez.gonzalez __at__ gmail.com>
#=

from apps.gymkhana.models import *
import api

def create(event, challenge, max_score, can_jump, proof_type, is_stop, position, target_place, min_distance, mark_place, augmented_reality):
    new_proof = Proof()
    new_proof.event = event
    new_proof.challenge = challenge
    new_proof.max_score = max_score
    new_proof.augmented_reality = augmented_reality
    if new_proof.max_score < 10:
      new_proof.max_score = 10

    new_proof.can_jump = can_jump
    new_proof.proof_type = proof_type
    new_proof.is_stop = is_stop

    if proof_type == 3: # Prueba de geolocalizacion
      new_proof.target_place = target_place
      new_proof.distance_to_target_place = min_distance
      new_proof.mark_place = mark_place

    # Inserto la nueva prueba en la posicion dada, y cambio el numero de prueba de todas las posteriores:
    proofs = event.proof_set.all()
    try:
      if position != "None": # Insertar prueba en posicion dada:
        if proofs:
          proof = proofs.get(id=position)
          numeral_position = proof.number
          new_proof.number = numeral_position
          for proof in proofs:
            if (proof.number >= numeral_position):
              proof.number = proof.number+1;
              proof.save()
          if len(proofs) == int(1):
            proof = proofs.get(id=position)
            new_proof.next_proof_id = proof.id
            new_proof.save()
            proof.next_proof_id = new_proof.id
            proof.save()
          else:
            proof = proofs.get(id=position)
            previous_proof = proofs.get(next_proof_id=proof.id)
            new_proof.next_proof_id = proof.id
            new_proof.save()
            previous_proof.next_proof_id = new_proof.id
            previous_proof.save()
            proof.save()
      else: # Anyadir prueba al final del resto:
        if len(proofs) > int(1):
          new_proof.number = len(proofs)+1
          last_proof = proofs.get(number=len(proofs))
          first_proof = proofs.get(number=int(1))
          new_proof.next_proof_id = first_proof.id
          new_proof.save()
          last_proof.next_proof_id = new_proof.id
          last_proof.save()
        elif len(proofs) == int(1):
          new_proof.number = len(proofs)+1
          last_proof = event.proof_set.get(number=int(1))
          new_proof.next_proof_id = last_proof.id
          new_proof.save()
          last_proof.next_proof_id = new_proof.id
          last_proof.save()
        else:
          new_proof.number = 1
          new_proof.next_proof_id = -1
    except: # Salta cuando no hay ninguna prueba y vamos a crear la primera
      new_proof.number = 1
      new_proof.next_proof_id = -1

    new_proof.save()

    return True, new_proof

def delete(event, proof_id):
    proofs = event.proof_set.all().order_by('number')
    for proof in proofs:
      if proof.id == proof_id:
        proof_to_delete = proof

    proof_number = proof_to_delete.number

    # Reenlazo la lista sacando de ella la prueba que borramos:
    if len(event.proof_set.all()) > int(2):
      previous_proof = event.proof_set.get(next_proof_id=proof_to_delete.id)
      next_proof = event.proof_set.get(id=proof_to_delete.next_proof_id)
      previous_proof.next_proof_id = next_proof.id
      previous_proof.save()
    elif len(event.proof_set.all()) == int(2):
      proof = event.proof_set.get(id=proof_to_delete.next_proof_id)
      proof.next_proof_id = -1
      proof.save()

    possible_solutions = proof_to_delete.solution_set.all()
    for possible_solution in possible_solutions:
      possible_solution.delete()
    responses = proof.response_set.all()
    for response in responses:
      response.delete()
    clues = proof.clue_set.all()
    for clue in clues:
      clue.delete()
    try: # Necesito hacer esto porque sino, al eliminar la prueba, recursivamente por las relaciones, borra los equipos
      all_teams = Team.objects.all()
      teams = proof_to_delete.team_set.all()
      for team in teams:
        first_proof = FirstProof(event=event,team=team,first_proof=None)
        first_proof.save()
        team.save()
    except:
      pass
    proof_to_delete.delete()

    proofs = event.proof_set.all().order_by('number')
    for proof in proofs:
      if (proof.number > int(proof_number)):
        proof.number = proof.number-1;
        proof.save()

    return True, "No Error."

def jump(team, proof):
    try:
      jumped_proof = JumpedProof.objects.get(proof=proof,team=team)
    except:
      jumped_proof = JumpedProof(proof=proof,team=team)
      jumped_proof.save()
    return True, jumped_proof

def jumped_list(team):
    jumped_proofs = JumpedProof.objects.filter(team=team).order_by("id")
    return True, jumped_proofs

def respond(event, team, proof, response_to_challenge, CORRECTION_FACTOR, position, altitude, distance_difference):
    scoreboard = Scoreboard.objects.get(event=event,team=team)
    if proof.proof_type == 2: # Si es una prueba fotografica
      correct, result = api.response.create(team, proof, None, response_to_challenge, None, position, altitude, distance_difference)
      message = "Continue"
      response = "PENDING"
      is_correct = False
      scoreboard.num_incorrect_responses = scoreboard.num_incorrect_responses + 1
    elif proof.proof_type == 3: # Si es una prueba de geolocalizacion
      correct, result = api.response.create(team, proof, None, None, True, position, altitude, distance_difference)
      message = "Continue"
      response = "CORRECT"
      is_correct = True
      scoreboard.num_correct_responses = scoreboard.num_correct_responses + 1
    else:  # Si es una prueba de respuesta textual ( proof.proof_type == 1 )
      solutions = proof.solution_set.all()
      success = 0
      for solution in solutions:
        if response_to_challenge.lower().strip() == solution.possible_solution.lower().strip():
          success = 1

      if success == 1:
        response = "CORRECT"
        scoreboard.num_correct_responses = scoreboard.num_correct_responses + 1
        message = "Continue"
      else:
        response = "INCORRECT"
        scoreboard.num_incorrect_responses = scoreboard.num_incorrect_responses + 1
        if proof.is_stop == True:
          message = "Repeat"
        else:
          message = "Continue"
      scoreboard.save()

      if response == "CORRECT":
        is_correct = True
      else:
        is_correct = False

      correct, result = api.response.create(team, proof, response_to_challenge, None, is_correct, position, altitude, distance_difference)

    if is_correct:
      scoreboard.score = scoreboard.score + proof.max_score
    else:
      scoreboard.score = scoreboard.score - round(proof.max_score * CORRECTION_FACTOR)
    scoreboard.save()

    return True, response, message
