/*
 * Copyright (c) 2009 GSyC/LibreSoft 
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License"); 
 *  you may not use this file except in compliance with the License. 
 *  You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *    	 
 *  Unless required by applicable law or agreed to in writing, software 
 *  distributed under the License is distributed on an "AS IS" BASIS, 
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *  See the License for the specific language governing permissions and 
 *  limitations under the License. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *  
 */

package com.LibreGeoSocial.Api;

import java.util.ArrayList;

public class User extends GeoNode  {

	private String  mName;	
	private String  mUsername;
	private String  mEmail;
	private String  mStatus;
	private String  mPassword;
	
	private ArrayList<User> mFriends;

	
	public User (Integer id, String name, String username, String email, String state,
			     Double latitude, Double longitude, Double radius, ArrayList<User> friends)
	{
		super(id,latitude,longitude,radius);
		

		mName = name;
		mUsername = username;
		mEmail = email;
		mStatus = state;
	
		mFriends = friends;
		
	}
	

	public String getName() {
		return mName;
	}
	public String getUsername() {
		return mUsername;
	}
	public String getEmail() {
		return mEmail;
	}
	public String getState() {
		return mStatus;
	}

	public ArrayList<User> getFriends()
	{
		return mFriends;
	}
	
	public String getPassword()
	{
		return mPassword;
	}
	
	public void setPassword (String password)
	{
		mPassword = password;
	}
}
