/*
 * Copyright (c) 2009 GSyC/LibreSoft 
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License"); 
 *  you may not use this file except in compliance with the License. 
 *  You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *    	 
 *  Unless required by applicable law or agreed to in writing, software 
 *  distributed under the License is distributed on an "AS IS" BASIS, 
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *  See the License for the specific language governing permissions and 
 *  limitations under the License. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *  		 Raúl Román <rroman@gsyc.es>
 *  
 */

package com.LibreGeoSocialApp;

import android.app.TabActivity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.TabHost;

public class GeoSocialTab extends TabActivity {

	@Override
    protected void onCreate(Bundle savedInstanceState) {
     
		super.onCreate(savedInstanceState);
		
		final TabHost tabHost = getTabHost();
		
		tabHost.addTab(tabHost.newTabSpec("Home")
                .setIndicator("home", this.getResources().getDrawable(R.drawable.home_38))          
                .setContent(new Intent(this, Home.class)));
		
		tabHost.addTab(tabHost.newTabSpec("Friends")				
                .setIndicator("Friends", this.getResources().getDrawable(R.drawable.users_two_38))
                .setContent(new Intent(this, FriendList.class)));
		
		tabHost.addTab(tabHost.newTabSpec("Config")				
                .setIndicator("Config", this.getResources().getDrawable(R.drawable.movistar))
                .setContent(new Intent(this, OMFConfig.class)));
			
		tabHost.computeScroll(); 
	}
}