/*
 * Copyright (c) 2009 GSyC/LibreSoft 
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License"); 
 *  you may not use this file except in compliance with the License. 
 *  You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *    	 
 *  Unless required by applicable law or agreed to in writing, software 
 *  distributed under the License is distributed on an "AS IS" BASIS, 
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *  See the License for the specific language governing permissions and 
 *  limitations under the License. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *  		 Raúl Román <rroman@gsyc.es>
 *  
 */



package com.LibreGeoSocialApp;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.LibreGeoSocial.Api.LibreGeoSocial;

public class LibreGeoSocialApp extends Activity implements OnClickListener {
	
    private static final int MENU_REGISTER = Menu.FIRST + 1;
    private static final int MENU_ABOUT = Menu.FIRST + 2;

    ImageView imgLS;
	Button btLogin;
	Button btRegister;
	
	TextView txtUser;
	TextView txtPasswd;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.login);
        
        txtUser = (TextView) this.findViewById(R.id.txtLogin);
        txtPasswd = (TextView) this.findViewById(R.id.txtPass);
        
        btLogin = (Button)this.findViewById(R.id.btLogin); 
        btLogin.setOnClickListener(this);
        
        btRegister = (Button)this.findViewById(R.id.btRegister); 
        btRegister.setOnClickListener(this);

        imgLS = (ImageView)this.findViewById(R.id.imgLS);
        imgLS.setImageResource(R.drawable.logo_nuevo);

        LibreGeoSocial.getInstance().setUrl("http://test.libregeosocial.libresoft.es/social/");
        LibreGeoSocial.getInstance().setFormat("JSON");
        
        
        
    }
    
    
    public void onClick(View v) { 
        
        if ( btLogin.isPressed() )
        {
	    	boolean login = LibreGeoSocial.getInstance().login( txtUser.getText().toString(), 
	    														txtPasswd.getText().toString());
	    	    	
	
	    	if (login)
	    	{
	    		Intent i = new Intent(this,GeoSocialTab.class);
	    		startActivity(i); 
	    	}
	    	else
	    	{
	    	
	    		Toast.makeText(getBaseContext(), 
	    					   "Error: " + LibreGeoSocial.getInstance().getLastMsgServer(), 
	    					   Toast.LENGTH_LONG).show();
	    		
	    	}
        }
        else if (btRegister.isPressed())
        {        	

    		Intent i = new Intent(this,Register.class);
        	startActivity(i);  
        }
    	
    }
    	
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	
        super.onCreateOptionsMenu(menu);
        menu.add(0, MENU_REGISTER, 0, "Register")
        		.setIcon(R.drawable.register)
                .setAlphabeticShortcut('A');
        
        menu.add(0, MENU_ABOUT, 0, "About")
			    .setIcon(R.drawable.icon)
		        .setAlphabeticShortcut('B');        
        
        return true;
    }
    
    @Override
    public boolean onOptionsItemSelected (MenuItem item) {
    	
    	switch (item.getItemId()) {
    	
    	case MENU_REGISTER:
    		
    		Intent i = new Intent(this,Register.class);
        	startActivity(i); 
        	
    		break;
    		
        case MENU_ABOUT:
        	
            break;
        }
        return super.onOptionsItemSelected(item);
    }



}

