/*
 * Copyright (c) 2009 GSyC/LibreSoft 
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License"); 
 *  you may not use this file except in compliance with the License. 
 *  You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *    	 
 *  Unless required by applicable law or agreed to in writing, software 
 *  distributed under the License is distributed on an "AS IS" BASIS, 
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *  See the License for the specific language governing permissions and 
 *  limitations under the License. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *  		 Raúl Román <rroman@gsyc.es>
 *  
 */

package com.LibreGeoSocialApp;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class OMFConfig extends Activity implements OnClickListener {
	
	private TextView txtNumber;
	private TextView txtPassword;
	private TextView txtLocPassword;
	private Button btSave;
	private static final int DIALOG_WELCOME = 1;
	static public String number = null;
	static public String password = null;
	static public String locpassword = null;
	
	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		
        setContentView(R.layout.omf_config);
        
        txtNumber = (TextView) this.findViewById(R.id.txtNumber);
        txtPassword = (TextView) this.findViewById(R.id.txtPassw);
        txtLocPassword = (TextView) this.findViewById(R.id.txtLocPassw);
        
        btSave = (Button)this.findViewById(R.id.btSaveConfig); 
        btSave.setOnClickListener(this);
        
        if (number!=null)
        	txtNumber.setText(number);
        
        if (password!=null)
        	txtPassword.setText(password);
        
        if (locpassword!=null)
        	txtLocPassword.setText(locpassword);
        
        showDialog(DIALOG_WELCOME);
    }
	
	
	public void onClick(View v) { 
	        
        if ( btSave.isPressed() )
        {
        	number = txtNumber.getText().toString();
        	password = txtPassword.getText().toString();
        	locpassword = txtLocPassword.getText().toString();
        	Toast.makeText(getBaseContext(), 
                    "Saved", 
                    Toast.LENGTH_LONG).show();
        }
	 }
	
    @Override
    protected Dialog onCreateDialog(int id) {
        
    	switch (id) {
	    	case DIALOG_WELCOME:
	    		
	    		LayoutInflater factory1 = LayoutInflater.from(this);
	    		final View textEntryView1 = factory1.inflate(R.layout.omf_welcome, null);
	    		
	    		ImageView logo = (ImageView)textEntryView1.findViewById(R.id.imgPop_up4Logo);
	    		logo.setImageResource(R.drawable.combo);
	    		
		        return new AlertDialog.Builder(this)	        
		        .setTitle("Welcome!")
		        .setView(textEntryView1)
		        .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
		            public void onClick(DialogInterface dialog, int whichButton) {
		            	
		            }
		        })
		        .create();
    	}
    	
    	return null;
    }
	
}
