/*
 * Copyright (c) 2009 GSyC/LibreSoft 
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License"); 
 *  you may not use this file except in compliance with the License. 
 *  You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *    	 
 *  Unless required by applicable law or agreed to in writing, software 
 *  distributed under the License is distributed on an "AS IS" BASIS, 
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *  See the License for the specific language governing permissions and 
 *  limitations under the License. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *  		 Raúl Román <rroman@gsyc.es>
 *  
 */

package com.LibreGeoSocialApp;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.LibreGeoSocial.Api.LibreGeoSocial;
import com.LibreGeoSocial.Api.User;

public class Register extends Activity implements OnClickListener {

	private Button btRegister;
	private TextView txtRealname;
	private TextView txtUsername;
	private TextView txtPassword;
	private TextView txtEmail;
	
    public void onCreate(Bundle icicle) {
    	
        super.onCreate(icicle);
        
        setContentView(R.layout.register);
        
        btRegister = (Button)this.findViewById(R.id.btRegister); 
        btRegister.setOnClickListener(this);
    
        txtRealname = (TextView) this.findViewById(R.id.txtName);
        txtUsername = (TextView) this.findViewById(R.id.txtUsername);
        txtPassword = (TextView) this.findViewById(R.id.txtPassword);
        txtEmail = (TextView) this.findViewById(R.id.txtEmail);
    
    }

	public void onClick(View v) {
		// TODO Auto-generated method stub
	
		User user = new User(0, txtRealname.getText().toString(),
								txtUsername.getText().toString(),
								txtEmail.getText().toString(),
								"",0.0, 0.0, 0.0, null);
								
		user.setPassword(txtPassword.getText().toString());
		
		
		
		if ( LibreGeoSocial.getInstance().registerUser(user) )
		{
    		Toast.makeText(getBaseContext(), 
					   "Correctly User registered!", 
					   Toast.LENGTH_LONG).show();
		}
		else
		{
    		Toast.makeText(getBaseContext(), 
					   "Error: " + LibreGeoSocial.getInstance().getLastMsgServer(), 
					   Toast.LENGTH_LONG).show();
		}
		
	}
}
