/*
 * Copyright (c) 2009 GSyC/LibreSoft 
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License"); 
 *  you may not use this file except in compliance with the License. 
 *  You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *    	 
 *  Unless required by applicable law or agreed to in writing, software 
 *  distributed under the License is distributed on an "AS IS" BASIS, 
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *  See the License for the specific language governing permissions and 
 *  limitations under the License. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *  
 */

package com.LibreGeoSocialApp.Resources;

import java.util.ArrayList;

import com.LibreGeoSocialApp.Utils.BitmapUtils;

import android.graphics.Bitmap;

public class PanoramioItem extends ResourceItem {

	
	private String 	mOwner; 
	private Bitmap 	mBitmapImage;
	private Bitmap  mBitmapThumb;
	private String  mUrlImage;
	private String  mUrlThumb;
	
	
	public PanoramioItem () {
		super();
	}
	
	public PanoramioItem (String title, String summary, String date,
			Double latitude, Double longitude, String url, String service,
			ArrayList<String> keywords) {
		super(title, summary, date, latitude, longitude, url, service, keywords);
	}

	
	public PanoramioItem (String title, String summary, String date,
			Double latitude, Double longitude, String url, String service,
			ArrayList<String> keywords, String owner, String urlImage, String urlThumb) {
	
		super(title, summary, date, latitude, longitude, url, service, keywords);
		
		mOwner = owner;
		mUrlImage = urlImage;
		mUrlThumb = urlThumb;
		
		mBitmapImage = BitmapUtils.loadBitmap(mUrlImage);
		mBitmapThumb = BitmapUtils.loadBitmap(mUrlThumb);
		
	}
	

	public String getOwner() {
		return mOwner;
	}

	public Bitmap getBitmapImage() {
		return mBitmapImage;
	}
	
	public Bitmap getBitmapThumb() {
		return mBitmapThumb;
	}
	
	
}
