/*
 * Copyright (c) 2009 GSyC/LibreSoft 
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License"); 
 *  you may not use this file except in compliance with the License. 
 *  You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *    	 
 *  Unless required by applicable law or agreed to in writing, software 
 *  distributed under the License is distributed on an "AS IS" BASIS, 
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *  See the License for the specific language governing permissions and 
 *  limitations under the License. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *  
 */

package com.LibreGeoSocialApp.Resources;

import java.util.ArrayList;

import android.graphics.Point;

public class ResourceItem {

	public static final int MILLION = 1000000;


	private String mTitle;
	private String mSummary;
	private String mDate;
	private Double mLatitude;
	private Double mLongitude;
	private String mUrl;
	private String mService;
	
	private ArrayList<String> mKeywords;
	private Point mLocation = null;

	public ResourceItem () {
		super();
	}
	
	public ResourceItem(String title, String summary, String date,
			Double latitude, Double longitude, String url, String service,
			ArrayList<String> keywords) {
		super();
		mTitle = title;
		
		if (summary==null)
			mSummary = "Without Description.";
		else
			mSummary = summary;
		
		mDate = date;
		mLatitude = latitude;
		mLongitude = longitude;
		mUrl = url;
		mService = service;
		mKeywords = keywords;
		
		mLocation = new Point (mLatitude.intValue(), mLongitude.intValue());

	}
	
	public String getTitle() {
		return mTitle;
	}
	public String getSummary() {
		return mSummary;
	}
	public String getDate() {
		return mDate;
	}
	public Double getLatitude() {
		return mLatitude;
	}
	public Double getLongitude() {
		return mLongitude;
	}
	public String getUrl() {
		return mUrl;
	}
	public String getService() {
		return mService;
	}
	public ArrayList<String> getKeywords() {
		return mKeywords;
	}
	
	public Point getLocation() {
		return mLocation;
	}
	
	
	

	
}
