/*
 * Copyright (c) 2009 GSyC/LibreSoft 
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License"); 
 *  you may not use this file except in compliance with the License. 
 *  You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *    	 
 *  Unless required by applicable law or agreed to in writing, software 
 *  distributed under the License is distributed on an "AS IS" BASIS, 
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *  See the License for the specific language governing permissions and 
 *  limitations under the License. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *  
 */

package com.LibreGeoSocialApp.Resources;

import java.util.ArrayList;

public class ResourceManager 
{
	public static final String PHOTO_RESOURCE  	= "panoramio";
	public static final String VIDEO_RESOURCE  	= "YOUTUBE";
	public static final String PLACES_RESOURCE 	= "11870";
	public static final String ALL_RESOURCE 	= "ALL";
	
	static private ResourceManager singleton = null;
	
	private ArrayList<ResourceItem> mPhotosResurce = new ArrayList<ResourceItem>();
	private ArrayList<ResourceItem> mVideosResource = new ArrayList<ResourceItem>();
	private ArrayList<ResourceItem> mPlacesResource = new ArrayList<ResourceItem>();
	
	static public ResourceManager getInstance() 
	{
        if (singleton == null) {
            singleton = new ResourceManager();
        }
        return singleton;
		
	}
	
	public void addResource (ResourceItem item, String resource)
	{
		getList(resource).add(item);	
	}
	
	public ResourceItem getResource (Integer position, String resource)
	{
		return getList(resource).get(position);
	}
		
	public Integer getSize(String resource)
	{
		return getList(resource).size();
	}
	
	public void reset()
	{
		mPhotosResurce.clear();
		mVideosResource.clear();
		mPlacesResource.clear();
	}

	private ArrayList<ResourceItem> getList (String resource)
	{
		
		if (resource.equals(PHOTO_RESOURCE))
			return mPhotosResurce;		
		else if (resource.equals(VIDEO_RESOURCE))
			return mVideosResource;
		
		else if (resource.equals(PLACES_RESOURCE))
			return mPlacesResource;
		else
			return null;
	}
}