package com.LibreGeoSocial.Api;

import android.graphics.Bitmap;
import android.util.Log;

import com.LibreGeoSocialApp.Utils.BitmapUtils;

public class Photo extends GeoNode  {

	private String mName;
	private String mDescription;
	private String mUrl;
	private String mSince;
	
	private Bitmap 	mBitmapImage;
	
	private User mUploader;
	
	public Photo (Integer id, Double latitude, Double longitude, Double radius, String name, String description, String url, String since, User uploader) 
	{
		super(id, latitude, longitude, radius);
		
		mName = name;
		mDescription = description;
		mUrl = url;
		mSince = since;
		
		mUploader = uploader;
		
		mBitmapImage = null;
	}

	public String getName() {
		return mName;
	}

	public void setName(String name) {
		mName = name;
	}

	public String getDescription() {
		return mDescription;
	}

	public void setDescription(String description) {
		mDescription = description;
	}

	public String getUrl() {
		return mUrl;
	}

	public void setUrl(String url) {
		mUrl = url;
	}

	public Bitmap getBitmapImage() {		
		
		if (mBitmapImage == null)
			mBitmapImage = LibreGeoSocial.getInstance().getBitmap(mUrl);
		
		return mBitmapImage;
	}
	
	public String getSince() {
		return mSince;
	}

	public void setSince(String since) {
		mSince = since;
	}

	public User getUploader() {
		return mUploader;
	}

	public void setUploader(User uploader) {
		mUploader = uploader;
	}

	
	
}
