/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocial.Api;

import java.util.ArrayList;

public class User extends GeoNode  {

	private String  mName;	
	private String  mLastName;
	private String  mUsername;
	private String  mEmail;
	private String  mStatus;
	private String  mPassword;
	
	private ArrayList<User> mFriends;
	private String mGroups;
	private String mPhotos;
	
	private String mCountry;
	private Integer mPostCode;
	private String mBirthday;
	
	public User (Integer id, String name, String lastName, String username, String email, String state,
			     Double latitude, Double longitude, Double radius, String country, 
			     Integer postCode, String birthday, ArrayList<User> friends)
	{
		super(id,latitude,longitude,radius);
		

		mName = name;
		mUsername = username;
		mEmail = email;
		mStatus = state;
	
		mFriends = friends;
		
		mCountry = country;
		mPostCode = postCode;
		mBirthday = birthday;
		
		mLastName = lastName;
		
	}
	

	public String getName() {
		return mName;
	}
	public String getLastName() {
		return mLastName;
	}
	public String getUsername() {
		return mUsername;
	}
	public String getEmail() {
		return mEmail;
	}
	public String getState() {
		return mStatus;
	}

	public ArrayList<User> getFriends()
	{
		return mFriends;
	}
	
	public String getPassword()
	{
		return mPassword;
	}
	
	public void setPassword (String password)
	{
		mPassword = password;
	}


	public String getCountry() {
		return mCountry;
	}


	public void setCountry(String country) {
		mCountry = country;
	}


	public Integer getPostCode() {
		return mPostCode;
	}


	public void setPostCode(Integer postCode) {
		mPostCode = postCode;
	}


	public String getBirthday() {
		return mBirthday;
	}


	public void setBirthday(String birthday) {
		mBirthday = birthday;
	}
}
