/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Raúl Román López <rroman@gsyc.es>
 *
 */

package com.LibreGeoSocialApp.Camera;

import java.util.ArrayList;
import java.util.concurrent.Semaphore;

import com.LibreGeoSocial.Api.GeoNode;
import com.LibreGeoSocial.Api.LibreGeoSocial;
import com.LibreGeoSocial.Api.Note;
import com.LibreGeoSocial.Api.Photo;
import com.LibreGeoSocial.Api.User;
import com.LibreGeoSocialApp.Home;
import com.LibreGeoSocialApp.Camera.Overlays.DrawArrow;
import com.LibreGeoSocialApp.Camera.Overlays.DrawFocus;
import com.LibreGeoSocialApp.Camera.Overlays.DrawParameters;
import com.LibreGeoSocialApp.Resources.ResourceItem;
import com.LibreGeoSocialApp.Resources.ResourceManager;
import com.LibreGeoSocialApp.Utils.LocationUtils;


import android.app.Activity;
import android.content.Context;
//import android.hardware.Sensor;
//import android.hardware.SensorEvent;
//import android.hardware.SensorEventListener;
import android.hardware.SensorListener;
import android.hardware.SensorManager;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.PowerManager;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.SubMenu;
import android.view.View;
import android.view.Window;
import android.view.View.OnTouchListener;
import android.view.ViewGroup.LayoutParams;
import android.widget.Toast;

public class CamView extends Activity{
	
	private static final int NSTEM = 20;
	private static final int MENU_RESOURCES = Menu.FIRST + 1;
//	private static final int MENU_ALL_RESOURCES = Menu.FIRST + 2;
	private static final int MENU_PANORAMIO_RESOURCES = Menu.FIRST + 3;
	private static final int MENU_11870_RESOURCES = Menu.FIRST + 4;
	private static final int MENU_LGS_RESOURCES = Menu.FIRST + 5;
	private static final int MENU_LOCATE= Menu.FIRST + 6;
	private static final int MENU_LOCATION_GPS = Menu.FIRST + 7;
	private static final int MENU_LOCATION_WIFI = Menu.FIRST + 8;
	
	private String LocationType;
	LocationManager mLocationManager = null;
	MyLocationListener mLocationListener = null;
	protected PowerManager.WakeLock mWakeLock;
	
    private CamPreview mPreview;
    private DrawParameters mParameters;
    private DrawFocus mFocus;
    private DrawArrow mArrow;
    
    private float location[];
    private String res_name;
    private static float resource_location[];
    private static float res_values[];
    private SensorManager sm;
    private MSensListener orListener;
    ArrayList<GeoNode> resourceList = null;
    ArrayList<ResourceItem> resourceOthersList = null;
    private boolean is_resource_clickable;
    private boolean is_clicked, refreshed;
    private float[] click_pos;
    
    private static int stem_counter;
    private static float[] mValues = new float[NSTEM];
    private static Semaphore sem;
    
	private String mPattern;
	private Double mDistance;
    
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        try {
        	
        	sem = new Semaphore(1, true);
        	
			location = new float[2];
			location[0] =  (float) Home.getLocation().getLatitude();
			location[1] = (float) Home.getLocation().getLongitude();
			
			// Hide the window title.
			requestWindowFeature(Window.FEATURE_NO_TITLE);
			
			// Create our Preview view and set it as the content of our activity.
			mPreview = new CamPreview(this);
			mPreview.setClickable(true);
			mPreview.setOnTouchListener(touchlistener);
			
			
			mParameters = new DrawParameters(this);
			mArrow = new DrawArrow(this);
			mFocus = new DrawFocus(this);
			
//			showContentView();
   
			final PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
			this.mWakeLock = pm.newWakeLock(PowerManager.SCREEN_BRIGHT_WAKE_LOCK, "My Tag");
			this.mWakeLock.acquire();
			
			is_resource_clickable = true;
			is_clicked = false;
			refreshed = false;
			click_pos = new float[2];
			
			mPattern = null;
			mDistance = 10.0;
			
			showResources(getIntent().getExtras().getString("RESOURCE_TYPE"));
			
			sm = (SensorManager) getSystemService(Context.SENSOR_SERVICE);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			Toast.makeText(getBaseContext(), 
					e.toString(), 
					Toast.LENGTH_LONG).show();
		}
        
        
    }
    
    OnTouchListener touchlistener = new OnTouchListener(){

		public boolean onTouch(View v, MotionEvent event) {
			// TODO Auto-generated method stub
			if(is_resource_clickable){
				switch (event.getAction()){
				
				case MotionEvent.ACTION_UP:
					click_pos[0] = event.getX();
					click_pos[1] = event.getY();
					is_clicked = true;
				default:
					break;
				}
			}else{
//				switch (event.getAction()){
//				
//				case MotionEvent.ACTION_UP:
//					//Stop location updates
//					if((mLocationManager!=null) && (mLocationListener!=null))
//						mLocationManager.removeUpdates(mLocationListener);
//
//					res_values = mValues;
//					resource_location = location;
//					try{
//						Intent i = new Intent(MyCamera.this,SetResourceName.class);
//						startActivityForResult(i, SET_NAME_OK);
//					}catch(Exception e){
//						Toast.makeText(getBaseContext(), 
//								e.toString(), 
//								Toast.LENGTH_LONG).show();
//					}
//					break;
//				default:
//					break;
//				}
			}
			
			return false;
		}
    	
    };
    
    private void setSensors(){
    	//Setting a sensor listener for orientation sensor
    	
    	try {
//			if(sm.getSensorList(Sensor.TYPE_ORIENTATION).isEmpty()){
//				Toast.makeText(getBaseContext(), 
//						"Unknown sensor", 
//						Toast.LENGTH_LONG).show();
//				return;
//			}
			
//			Sensor orsensor = sm.getSensorList(Sensor.TYPE_ORIENTATION).get(0);
    		
    		int orsensor = SensorManager.SENSOR_ORIENTATION;
			
			if (orListener == null)
				orListener = new MSensListener();
			
			sm.registerListener(orListener, orsensor, SensorManager.SENSOR_DELAY_FASTEST);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			Toast.makeText(getBaseContext(), 
					e.toString(), 
					Toast.LENGTH_LONG).show();
		}
    }
    
    private void showResources(String type){
    	refreshed = false;
    	if(type.equals("lgs_resource")){
    		//reading resources
    		mDistance = getIntent().getExtras().getDouble("LGS_DISTANCE");
    		mPattern = getIntent().getExtras().getString("LGS_PATTERN");
    		
    		resourceList = LibreGeoSocial.getInstance().getPhotos(mDistance,mPattern);
    		resourceList.addAll(LibreGeoSocial.getInstance().getNotes(mDistance,mPattern));
    		resourceList.addAll(LibreGeoSocial.getInstance().getUserList(true,mDistance,mPattern));
    		
    		if(resourceList!=null)
    			showContentView();
    		else
    			Toast.makeText(getBaseContext(), 
    					"No resources available", 
    					Toast.LENGTH_LONG).show();
    		//resources will be drawn when the sensor is refreshed
        	
    		refreshed = true;
    		return;
    	}
    	
    	else if(type.equals(ResourceManager.PLACES_RESOURCE)){
    		
    		resourceOthersList = ResourceManager.getInstance().getList(ResourceManager.PLACES_RESOURCE);
    		if (resourceOthersList != null){
    			showContentView();
    		}else{
    			Toast.makeText(getBaseContext(), 
    					"No resources available", 
    					Toast.LENGTH_LONG).show();
    		}
    		//resources will be drawn when the sensor is refreshed
        	
    		refreshed = true;
    		return;
    	}
    	
    	else if(type.equals(ResourceManager.PHOTO_RESOURCE)){
    		
    		resourceOthersList = ResourceManager.getInstance().getList(ResourceManager.PHOTO_RESOURCE);
    		if (resourceOthersList != null){
    			showContentView();
    		}else{
    			Toast.makeText(getBaseContext(), 
    					"No resources available", 
    					Toast.LENGTH_LONG).show();
    		}
    		//resources will be drawn when the sensor is refreshed
        	
    	}
    	
    	refreshed = true;
    }
    
    private void showContentView(){
    	setContentView(mPreview);
        addContentView(mParameters, new LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
        addContentView(mFocus, new LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
        addContentView(mArrow, new LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
    }
    
    private float getElevation(float[] values){
    	float elevation = 0;
    	
    	if(values!=null){
			elevation = -values[5];
			if(Math.abs(values[4])>100)
				elevation = 180 - elevation;
		}
    	return elevation;
    }
    
    private float getAzimuth(float[] values){
    	float azimuth = 0;
    	
    	if(values!=null){
			azimuth = values[3] + 90;
			if(azimuth>=360)
				azimuth -= 360;
		}
    	
    	return azimuth;
    }
    
    private int calculateMinMax(float[] vector, boolean is_min){
    	int res = 0;
    	float value;
    	
    	if(is_min)
    		value = 1000;
    	else
    		value = -1000;
    	
    	for(int i = (vector.length - 1); i >=0; i--){
    		if(is_min){
    			if(vector[i]<value){
    				value = vector[i];
    				res = i;
    			}
    		}else{
    			if(vector[i]>value){
    				value = vector[i];
    				res = i;
    			}
    		}
    	}
    	
    	return res;
    }
    
//    private void saveResource(){
//    	
//    	//Calculate where is the resource
//    	float[] res_location = ResourceLocationUtils.calculateIntersection(resource_location, getAzimuth(res_values));
//    	float res_distance = ResourceLocationUtils.coord2Distance(location, res_location);
//    	float res_height = ResourceLocationUtils.calculateResourceHeight(getElevation(res_values), res_distance);
//    	
//    	ResourceLGS resource = new ResourceLGS(getBaseContext(), res_name, res_location[0], res_location[1], res_height);
//		resource.saveResource();
//		
//		Toast.makeText(getBaseContext(), 
//				"Saved " + Float.toString(res_height), 
//				Toast.LENGTH_LONG).show();
//		
//		float res_azimuth = resource.azimuthToResource(location);
//		float azimuth = ResourceLocationUtils.calculateAzimuthFromUser(getAzimuth(mValues),res_azimuth);
//
//		float res_roll = resource.rollToResource(resource.distanceToResource(location));
//		float elevation = ResourceLocationUtils.calculateRollFromUser(getElevation(mValues), res_roll);
//		
//		resource.setDrawnValues(azimuth, elevation, 1);
//		if(resources_list!=null)
//			resources_list.add(resource);
//		is_resource_clickable = true;
//    }
	
	private void locateUser(){
		try {
			mLocationManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
			
			if (mLocationManager.isProviderEnabled(LocationType)) {
				
				mLocationListener = new MyLocationListener();
				
				mLocationManager.requestLocationUpdates(
						LocationType, 0, 0, mLocationListener);
			} else {
			    Toast.makeText(getBaseContext(), 
			            "Unable to locate", 
			            Toast.LENGTH_LONG).show();
			    
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			Toast.makeText(getBaseContext(), 
					e.toString(), 
					Toast.LENGTH_LONG).show();
		}
	}
    
    protected void onPause(){
    	super.onPause();
    	sm.unregisterListener(orListener);
    	if((mLocationManager!=null) && (mLocationListener!=null))
    		mLocationManager.removeUpdates(mLocationListener);
    	
    }
    
    protected void onResume(){
    	super.onResume();
    	setSensors();
    }
    
    protected void onDestroy(){
    	
    	this.mWakeLock.release();
    	super.onDestroy();
    }
    
//    public void onActivityResult(int requestCode, int resultCode, Intent data){
//    	super.onActivityResult(requestCode, resultCode, data);
//    	switch(requestCode){
//    	
//    	case SET_NAME_OK:
//    		if(resultCode == Activity.RESULT_OK){
//    			res_name = data.getStringExtra(NAME);
//    			if(res_name.equals("")){
//    				Toast.makeText(getBaseContext(), 
//    						"Invalid name", 
//    						Toast.LENGTH_LONG).show();
//    				is_resource_clickable = true;
//    				break;
//    			}
//    			saveResource();
//    		} else {
//    			is_resource_clickable = true;
//    		}
//    		break;
//    	default:
//    		break;
//    	}
//    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	
    	SubMenu sub1 = menu.addSubMenu (0, MENU_RESOURCES, 0 ,"Resources");
    	sub1.add(0,MENU_LGS_RESOURCES,0,"LGS");
    	sub1.add(0,MENU_11870_RESOURCES,0,"Places");
    	sub1.add(0,MENU_PANORAMIO_RESOURCES,0,"Photos");
//        menu.add(0, MENU_LOAD_OTHER_RESOURCES, 0 ,"Load Others");
//        menu.add(0,MENU_REMOVE_RESOURCE,0,"Remove");
        SubMenu sub2 = menu.addSubMenu (0, MENU_LOCATE, 0 , "Locate");
        sub2.add(0,MENU_LOCATION_GPS,0, "GPS");
        sub2.add(0,MENU_LOCATION_WIFI,0, "WIFI");
        
        super.onCreateOptionsMenu(menu);        
        return true;
    }

    public boolean onOptionsItemSelected (MenuItem item) {
    	
    	switch (item.getItemId()) {
    		
    	case MENU_LGS_RESOURCES:
        	
    		refreshed = false;
    		//reading resources
    		
    		if(resourceOthersList!=null)
    			resourceOthersList.clear();
    		
    		resourceList = LibreGeoSocial.getInstance().getPhotos(mDistance,mPattern);
    		resourceList.addAll(LibreGeoSocial.getInstance().getNotes(mDistance,mPattern));
    		resourceList.addAll(LibreGeoSocial.getInstance().getUserList(true,mDistance,mPattern));
    		
    		showContentView();
    		//resources will be drawn when the sensor is refreshed
        	
    		refreshed = true;
    		break;
    		
    	case MENU_11870_RESOURCES:
        	
    		refreshed = false;
    		//reading resources
    		
    		if(resourceList!=null)
    			resourceList.clear();
    		
    		ResourceManager.getInstance().refreshList(ResourceManager.PLACES_RESOURCE);
    		
    		resourceOthersList = ResourceManager.getInstance().getList(ResourceManager.PLACES_RESOURCE);
    		
    		showContentView();
    		//resources will be drawn when the sensor is refreshed
        	
    		refreshed = true;
    		break;
    		
    	case MENU_PANORAMIO_RESOURCES:
        	
    		refreshed = false;
    		//reading resources
    		
    		if(resourceList!=null)
    			resourceList.clear();
    		
    		ResourceManager.getInstance().refreshList(ResourceManager.PHOTO_RESOURCE);
    		
    		resourceOthersList.addAll(ResourceManager.getInstance().getList(ResourceManager.PHOTO_RESOURCE));
    		
    		showContentView();
    		//resources will be drawn when the sensor is refreshed
        	
    		refreshed = true;
    		break;
    		
//    	case MENU_SAVE_RESOURCE:
//    		
//    		is_resource_clickable = false;
//    		
//    		break;
//    		
    		
    	case MENU_LOCATION_GPS:
    		LocationType = LocationManager.GPS_PROVIDER;
    		locateUser();
    		break;
    		
    	case MENU_LOCATION_WIFI:
    		LocationType = LocationManager.NETWORK_PROVIDER;
    		locateUser();
    		break;
        }
        return super.onOptionsItemSelected(item);
    }
	
	private class MyLocationListener implements LocationListener{

	        public void onLocationChanged(Location loc) {
	            if (loc != null) {
	            	location[0] = (float)loc.getLatitude();
	            	location[1] = (float)loc.getLongitude();
	                //LocManager.setMCoords(location);
	            }
	        }


	        public void onProviderDisabled(String provider) {
	            // TODO Auto-generated method stub
	        }


	        public void onProviderEnabled(String provider) {
	            // TODO Auto-generated method stub
	        }


	        public void onStatusChanged(String provider, int status, 
	            Bundle extras) {
	            // TODO Auto-generated method stub
	        }
	    }
    
    private class MSensListener implements SensorListener{
    	
    	private void refreshResourceLGSDrawns(float[] values){
    		boolean isclicked = is_clicked;
    		
    		if(resourceList==null)
				return;
			if(resourceList.isEmpty())
				return;
			
			int sizeList = resourceList.size();
			
			for(int i=sizeList; i>0; i--){
				GeoNode resource = resourceList.get(i-1);
				
				float distance = resource.distanceToResource(location);
				float res_azimuth = resource.azimuthToResource(location);
        		float azimuth = LocationUtils.calculateAzimuthFromUser(getAzimuth(values),res_azimuth);
        		
        		float res_roll = resource.rollToResource(resource.distanceToResource(location));
        		float elevation = LocationUtils.calculateRollFromUser(getElevation(values), res_roll);
        		
        		if (!resourceList.get(i-1).isLoaded()){
        			//Initialize the draw element
        			String name = "Unamed";
        			if ( Photo.class.isInstance(resource) )    	
        	        {
        	        	Photo myphoto = (Photo) resourceList.get(i-1);
        	        	name = myphoto.getName();
        	        }
        	        else if (Note.class.isInstance(resource) )
        	        {
        	        	Note mynote = (Note) resourceList.get(i-1);
        	        	name = mynote.getTitle();
        	        }
        	        else if ( User.class.isInstance(resource))
        	        {
        	        	User myuser = (User) resourceList.get(i-1);
        	        	name = myuser.getName() + " (" + myuser.getUsername() +")";
        	        }
        			
        			resourceList.get(i-1).createDrawn(getBaseContext(), name);
        		}
        		
        		resourceList.get(i-1).setDrawnValues(azimuth, elevation, distance);
        		
        		if(isclicked){
        			float pos[] = resourceList.get(i-1).getDrawnPosition();
        			float distx = click_pos[0] - pos[0];
        			float disty = click_pos[1] - pos[1];

    				if(Math.sqrt(Math.pow(distx, 2) + Math.pow(disty, 2)) < (35)){
    					resourceList.get(i-1).drawDistance(true);
    					resourceList.get(i-1).bringDrawnToFront();
    				}else{
    					resourceList.get(i-1).drawDistance(false);
    				}
        		}
        		
        		if(!resourceList.get(i-1).isLoaded()){
        			resourceList.get(i-1).setLoaded(true);
    				addContentView(resourceList.get(i-1).getDrawn(), 
    						new LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
    			}
        		resourceList.get(i-1).invalidateDrawn();
				
			}
    	}

    	private void refreshResourceOtherDrawns(float[] values){
    		boolean isclicked = is_clicked;
    		
    		if(resourceOthersList==null)
    			return;
    		if(resourceOthersList.isEmpty())
    			return;

    		int sizeList = resourceOthersList.size();

    		for(int i=sizeList; i>0; i--){
    			ResourceItem resource = resourceOthersList.get(i-1);

    			float distance = resource.distanceToResource(location);
    			float res_azimuth = resource.azimuthToResource(location);
    			float azimuth = LocationUtils.calculateAzimuthFromUser(getAzimuth(values),res_azimuth);

    			float res_roll = resource.rollToResource(resource.distanceToResource(location));
    			float elevation = LocationUtils.calculateRollFromUser(getElevation(values), res_roll);

    			if (!resourceOthersList.get(i-1).isLoaded()){
    				//Initialize the draw element
    				String name = resource.getTitle();
    				resourceOthersList.get(i-1).createDrawn(getBaseContext(), name);
    			}

    			resourceOthersList.get(i-1).setDrawnValues(azimuth, elevation, distance);

    			if(isclicked){
    				float pos[] = resourceOthersList.get(i-1).getDrawnPosition();
    				float distx = click_pos[0] - pos[0];
    				float disty = click_pos[1] - pos[1];

    				if(Math.sqrt(Math.pow(distx, 2) + Math.pow(disty, 2)) < (25)){
    					resourceOthersList.get(i-1).drawDistance(true);
    					resourceOthersList.get(i-1).bringDrawnToFront();
    				}else{
    					resourceOthersList.get(i-1).drawDistance(false);
    				}
    			}

    			if(!resourceOthersList.get(i-1).isLoaded()){
    				resourceOthersList.get(i-1).setLoaded(true);
    				addContentView(resourceOthersList.get(i-1).getDrawn(), 
    						new LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
    			}
    			resourceOthersList.get(i-1).invalidateDrawn();

    		}
    	}
    	


		public void onAccuracyChanged(int sensor, int accuracy) {
			// TODO Auto-generated method stub
			
		}

		
		public void onSensorChanged(int sensor, float[] values) {
			// TODO Auto-generated method stub
			switch (sensor){

			case SensorManager.SENSOR_ORIENTATION:
				//mValues = values;
				float[] values_new = values;
				
				if(sem.tryAcquire()){
					if(stem_counter < NSTEM){
						mValues[stem_counter] = values_new[3];
						stem_counter++;
						sem.release();
						break;
					}else{
						float sum = 0;
						for(int i=0; i<NSTEM; i++){
							sum += mValues[i];
						}
						values_new[3] = sum/(stem_counter - 2);
						stem_counter = 0;
					}
					sem.release();
				}else
					break;
					
				
				//THIS PART IS CRITICAL IN ORDER TO REFRESH THE VIEW!!!
				if(mParameters!=null){
					mParameters.setValues(values_new, location);
					mParameters.invalidate();
				}
				
				if(mArrow!=null){
					mArrow.setAzimuth(getAzimuth(values_new));
					mArrow.invalidate();
				}
				
				if (refreshed){
					refreshResourceLGSDrawns(values_new);
					refreshResourceOtherDrawns(values_new);

					is_clicked = false;
				}
				
			}
		}

    }
	
	// Cupcake version:
//    private class MSensListener implements SensorEventListener{
//
//    	public void onSensorChanged(SensorEvent event) {
//    		
//    		try {
//				switch (event.sensor.getType()){
//
//				case Sensor.TYPE_ORIENTATION:
//					mValues = event.values;
//					
//					//THIS PART IS CRITICAL IN ORDER TO REFRESH THE VIEW!!!
//					if(mParameters!=null){
//						mParameters.setValues(event.values, location);
//						mParameters.invalidate();
//					}
//					
//					if (refreshed){
//						refreshResourceLGSDrawns(event.values);
//						refreshResourceOtherDrawns(event.values);
//
//						is_clicked = false;
//					}
//					
//				}
//			} catch (Exception e) {
//				// TODO Auto-generated catch block
//				Toast.makeText(getBaseContext(), 
//						e.toString(), 
//						Toast.LENGTH_LONG).show();
//			}
//
//    	} 
//    	
//    	private void refreshResourceLGSDrawns(float[] values){
//    		boolean isclicked = is_clicked;
//    		
//    		if(resourceList==null)
//				return;
//			if(resourceList.isEmpty())
//				return;
//			
//			int sizeList = resourceList.size();
//			
//			for(int i=sizeList; i>0; i--){
//				GeoNode resource = resourceList.get(i-1);
//				
//				float distance = resource.distanceToResource(location);
//				float res_azimuth = resource.azimuthToResource(location);
//        		float azimuth = LocationUtils.calculateAzimuthFromUser(getAzimuth(values),res_azimuth);
//        		
//        		float res_roll = resource.rollToResource(resource.distanceToResource(location));
//        		float elevation = LocationUtils.calculateRollFromUser(getElevation(values), res_roll);
//        		
//        		if (!resourceList.get(i-1).isLoaded()){
//        			//Initialize the draw element
//        			String name = "Unamed";
//        			if ( Photo.class.isInstance(resource) )    	
//        	        {
//        	        	Photo myphoto = (Photo) resourceList.get(i-1);
//        	        	name = myphoto.getName();
//        	        }
//        	        else if (Note.class.isInstance(resource) )
//        	        {
//        	        	Note mynote = (Note) resourceList.get(i-1);
//        	        	name = mynote.getTitle();
//        	        }
//        	        else if ( User.class.isInstance(resource))
//        	        {
//        	        	User myuser = (User) resourceList.get(i-1);
//        	        	name = myuser.getName() + " (" + myuser.getUsername() +")";
//        	        }
//        			
//        			resourceList.get(i-1).createDrawn(getBaseContext(), name);
//        		}
//        		
//        		resourceList.get(i-1).setDrawnValues(azimuth, elevation, distance);
//        		
//        		if(isclicked){
//        			float pos[] = resourceList.get(i-1).getDrawnPosition();
//        			float distx = click_pos[0] - pos[0];
//        			float disty = click_pos[1] - pos[1];
//
//    				if(Math.sqrt(Math.pow(distx, 2) + Math.pow(disty, 2)) < (25)){
//    					resourceList.get(i-1).drawDistance(true);
//    					resourceList.get(i-1).bringDrawnToFront();
//    				}else{
//    					resourceList.get(i-1).drawDistance(false);
//    				}
//        		}
//        		
//        		if(!resourceList.get(i-1).isLoaded()){
//        			resourceList.get(i-1).setLoaded(true);
//    				addContentView(resourceList.get(i-1).getDrawn(), 
//    						new LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
//    			}
//        		resourceList.get(i-1).invalidateDrawn();
//				
//			}
//    	}
//
//    	private void refreshResourceOtherDrawns(float[] values){
//    		boolean isclicked = is_clicked;
//    		
//    		if(resourceOthersList==null)
//				return;
//			if(resourceOthersList.isEmpty())
//				return;
//			
//			int sizeList = resourceOthersList.size();
//			
//			for(int i=sizeList; i>0; i--){
//				ResourceItem resource = resourceOthersList.get(i-1);
//				
//				float distance = resource.distanceToResource(location);
//				float res_azimuth = resource.azimuthToResource(location);
//        		float azimuth = LocationUtils.calculateAzimuthFromUser(getAzimuth(values),res_azimuth);
//        		
//        		float res_roll = resource.rollToResource(resource.distanceToResource(location));
//        		float elevation = LocationUtils.calculateRollFromUser(getElevation(values), res_roll);
//        		
//        		if (!resourceOthersList.get(i-1).isLoaded()){
//        			//Initialize the draw element
//        			String name = resource.getTitle();
//        			resourceOthersList.get(i-1).createDrawn(getBaseContext(), name);
//        		}
//        		
//        		resourceOthersList.get(i-1).setDrawnValues(azimuth, elevation, distance);
//        		
//        		if(isclicked){
//        			float pos[] = resourceOthersList.get(i-1).getDrawnPosition();
//        			float distx = click_pos[0] - pos[0];
//        			float disty = click_pos[1] - pos[1];
//
//    				if(Math.sqrt(Math.pow(distx, 2) + Math.pow(disty, 2)) < (25)){
//    					resourceOthersList.get(i-1).drawDistance(true);
//    					resourceOthersList.get(i-1).bringDrawnToFront();
//    				}else{
//    					resourceOthersList.get(i-1).drawDistance(false);
//    				}
//        		}
//        		
//        		if(!resourceOthersList.get(i-1).isLoaded()){
//        			resourceOthersList.get(i-1).setLoaded(true);
//    				addContentView(resourceOthersList.get(i-1).getDrawn(), 
//    						new LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
//    			}
//        		resourceOthersList.get(i-1).invalidateDrawn();
//				
//			}
//    	}
//    	
//    	
//    	
//		@Override
//		public void onAccuracyChanged(Sensor sensor, int accuracy) {
//			// TODO Auto-generated method stub
//			
//		}
//
//    }
}
