package com.LibreGeoSocialApp.Camera.Overlays;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.RectF;
import android.view.View;


public class DrawFocus extends View{

	private static final float mRADIUS = 55;
	
	public DrawFocus(Context context) {
		super(context);
		// TODO Auto-generated constructor stub
	}
	
	@Override
	protected void onDraw(Canvas canvas){
		
		Paint paint = new Paint();
		paint.setStyle(Paint.Style.FILL);
		paint.setColor(Color.WHITE);
		paint.setFakeBoldText(true);
		
		int w = canvas.getWidth();
        int h = canvas.getHeight();
        int cx = (w) / 2;
        int cy = (h) / 2;
		
		float[] points1 = {cx - 5, cy + 10,
				cx - 10, cy + 10,
				cx - 10, cy + 10,
				cx - 10, cy - 10,
				cx - 10, cy - 10,
				cx - 5, cy - 10};
		
		float[] points2 = {cx + 5, cy + 10,
				cx + 10, cy + 10,
				cx + 10, cy + 11,
				cx + 10, cy - 10,
				cx + 10, cy - 10,
				cx + 5, cy - 10};
		
		Paint paint_radar = new Paint();
		paint_radar.setARGB(127,127,255,127);
		paint_radar.setAntiAlias(true);
		
		RectF oval = new RectF (cx + 160 - mRADIUS, cy + 75 - mRADIUS,
				cx + 160 + mRADIUS, cy + 75 + mRADIUS);
		
		canvas.drawOval(oval,paint_radar);
		canvas.drawText ("N", cx + 156, cy + 75 - mRADIUS + 10, paint);
		canvas.drawText ("E", cx + 160 + mRADIUS - 8, cy + 79, paint);
		canvas.drawText ("S", cx + 156, cy + 75 + mRADIUS -2, paint);
		canvas.drawText ("O", cx + 160 - mRADIUS + 2, cy + 79, paint);
		canvas.drawLines(points1, paint);
		canvas.drawLines(points2, paint);
		
		
		super.onDraw(canvas);
	}
}