package com.LibreGeoSocialApp.Camera.Overlays;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.View;

public class DrawParameters extends View{
	
	private float mValues[] = null;
	private float coords[] = null;
	
	public DrawParameters(Context context) {
		super(context);
		// TODO Auto-generated constructor stub
	}
	
	public void setValues (float[] values, float[] location){
		mValues = values;
		coords = location;
	}
	
	@Override
	protected void onDraw(Canvas canvas){
		float azimuth=0, elevation=0;
		
		Paint paint = new Paint();
		paint.setStyle(Paint.Style.FILL);
		paint.setColor(Color.RED);
		
		if(mValues!=null){
			azimuth = mValues[3] + 90;
			if(azimuth>360)
				azimuth -= 360;
			
			elevation = -mValues[5];
			if(Math.abs(mValues[4])>100)
				elevation = 180 - elevation;
		}
		
		canvas.drawText("Azimuth = " + Float.toString(azimuth), 10, 10, paint);
		canvas.drawText("Elevation = " + Float.toString(elevation), 10, 20, paint);
		
		if(coords!=null)
			canvas.drawText("(" +
					Float.toString(coords[0]) + ", " +
					Float.toString(coords[1]) + ")", 10, 30, paint);
		super.onDraw(canvas);
	}
}