/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocialApp;

import java.util.List;

import android.content.Intent;
import android.os.Bundle;
import android.widget.ImageView;
import android.widget.TextView;
 
import com.LibreGeoSocialApp.Overlay.MapOverlay;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;

public class NoteCard extends MapActivity {

	
	private ImageView imageUser;
	private TextView lbTitle, lbBody, lbDate;

	private MapView mapView;
	
	private Double latitude, longitude;

    public void onCreate(Bundle icicle) {
    	
         super.onCreate(icicle);
        
         setContentView(R.layout.note_card); 
         
         imageUser = (ImageView)this.findViewById(R.id.img);
         imageUser.setImageResource(R.drawable.paper_pencil_48); 

         lbTitle = (TextView) this.findViewById(R.id.lbTitle);
         lbBody = (TextView) this.findViewById(R.id.lbBody);   
         lbDate = (TextView) this.findViewById(R.id.lbDate);
          
         
         Intent i = getIntent();
         
         String title  = i.getStringExtra("title");
         String body   = i.getStringExtra("body");
         String date   = i.getStringExtra("date");
         
         latitude = i.getDoubleExtra("latitude", Integer.MIN_VALUE);
         longitude = i.getDoubleExtra("longitude", Integer.MIN_VALUE);
         
         
         
         lbTitle.setText (title);
         lbBody.setText  (body);
         lbDate.setText  ("Written: " + date);                  
         
         
         showMap();
        
    }

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
    private void showMap()
    {
    	
        mapView = (MapView) findViewById(R.id.myMapView);
    	 
        MapController mapControl = mapView.getController();
        
        
        GeoPoint geoPoint = new GeoPoint(  (int) (latitude * 1000000), 
        						  		   (int) (longitude * 1000000));
        mapControl.setZoom(20);
        mapControl.setCenter(geoPoint);
        
	    /* Config overlay */
	    MapOverlay myMapOver = new MapOverlay();
	    myMapOver.setDrawable(getResources().getDrawable(R.drawable.paper_pencil_48));
	    myMapOver.setGeoPoint(geoPoint);
	   
	   
        final List<Overlay> overlays = mapView.getOverlays();
        overlays.add(myMapOver);
	    
	    mapView.setClickable(true);
        
    }
}

