/*
*
*  Copyright (C) 2009 GSyC/LibreSoft
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see http://www.gnu.org/licenses/. 
*
*  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
*
*/

package com.LibreGeoSocialApp.Overlay;

import java.util.ArrayList;

import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Point;

import com.LibreGeoSocial.Api.GeoNode;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.Projection;

public class RoutePathOverlay extends Overlay {
	
	private final int mRadius = 5;
	
	private ArrayList<GeoNode> mRoutePath;
	
	public void setRoutePath (ArrayList<GeoNode> traces)
	{
		mRoutePath = traces;
	}
	
	@Override
	public void draw(Canvas canvas, MapView mapView, boolean shadow)
	{
	
		for (int i=0; i<mRoutePath.size()-1; i=i+1)
		{
			
	        GeoPoint geoPointSource = new GeoPoint( (int) (mRoutePath.get(i).getLatitude() * 1000000), 
					  						   		(int) (mRoutePath.get(i).getLongitude() * 1000000));
	        
	        GeoPoint geoPointDestination = new GeoPoint( (int) (mRoutePath.get(i+1).getLatitude() * 1000000),
	        											 (int) (mRoutePath.get(i+1).getLongitude() * 1000000));
	        
	        
			Point source = new Point();
			Point destination = new Point();
			
			Projection projection = mapView.getProjection();
		        
			projection.toPixels(geoPointSource, source);
			projection.toPixels(geoPointDestination, destination);
			
		        
			Paint paint = new Paint();
			paint.setARGB(250,255,0,0);
			paint.setAntiAlias(true);
			paint.setFakeBoldText(true);
			paint.setStrokeWidth(4);
			
			canvas.drawLine (source.x, source.y,
							 destination.x, destination.y,
							 paint);

		}
	}

}
