/*
 *
 *  Copyright (C) 2008 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocialApp;

import java.util.List;

import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.SubMenu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.LibreGeoSocial.Api.LibreGeoSocial;
import com.LibreGeoSocial.Api.User;
import com.LibreGeoSocialApp.Overlay.PositionOverlay;
import com.LibreGeoSocialApp.Resources.ResourceManager;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;

public class Home extends MapActivity implements Runnable, OnClickListener  {
	
    private ProgressDialog pd;
    
	LocationManager mLocationManager;
	Location mLocation;
	MyLocationListener mLocationListener;
	
	static Location currentLocation = null;
	
	TextView outlat;
	TextView outlong;
	Button btUpdateLocation;
	MapView mapView;
	ImageView imageUser;
	TextView txtUserName;
	TextView txtState;
	
	private static final int MENU_RESOURCES = Menu.FIRST + 1;
	private static final int MENU_STATE = Menu.FIRST + 2;
	private static final int MENU_LOCATION = Menu.FIRST + 3;
	private static final int MENU_LOCATION_GPS = Menu.FIRST + 4;
	private static final int MENU_LOCATION_WIFI = Menu.FIRST + 5;
	
	private static final int DIALOG_UPDATE_STATE = 1;
	private String LocationType;
	
	private GeoPoint geoPoint;
	
	private User user;
	
	public static Location getLocation()
	{
		return currentLocation;
	}
	
    public void onCreate(Bundle icicle) {
    	
        super.onCreate(icicle);
        
        setContentView(R.layout.home);
        
        LocationType = LocationManager.GPS_PROVIDER;
        
        btUpdateLocation = (Button)this.findViewById(R.id.btLocation); 
        btUpdateLocation.setOnClickListener(this);
        
        imageUser = (ImageView)this.findViewById(R.id.imgUser);
        imageUser.setImageResource(R.drawable.user_48);

        txtUserName = (TextView) this.findViewById(R.id.lbName);
        txtState = (TextView) this.findViewById(R.id.lbState);
        
        //writeSignalGPS();
                
        user = LibreGeoSocial.getInstance().getInfoUser(true, null);
        
        txtUserName.setText (user.getName());
        txtState.setText(user.getState());             
        
        
    }
    
    private void setCurrentLocation(Location loc) {
    	currentLocation = loc;	
    	LibreGeoSocial.getInstance().setUserPosition(loc.getLatitude(), loc.getLongitude());
    }
    
	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		
		writeSignalGPS(); 
		
	}
    
    
    private void writeSignalGPS() {
    	
    	DialogInterface.OnCancelListener dialogCancel = new DialogInterface.OnCancelListener() {

            public void onCancel(DialogInterface dialog) {

            }
          
        };
    	
		pd = ProgressDialog.show(this, this.getResources().getString(R.string.search), 
				this.getResources().getString(R.string.search_signal_gps), true, true, dialogCancel);
		
		Thread thread = new Thread(this);
		thread.start();

    }
    
    private void showMap()
    {
    	
        mapView = (MapView) findViewById(R.id.myMapView);
    	 
    	//mapView = new MapView(this, "0Tp7WsIDiyqp_gJLEiO55RXtkz7VsxOjQvL44SA");
        MapController mapControl = mapView.getController();
        
        
        geoPoint = new GeoPoint(  (int) (currentLocation.getLatitude() * 1000000), 
        						  (int) (currentLocation.getLongitude() * 1000000));
        mapControl.setZoom(20);
        mapControl.setCenter(geoPoint);
        
        PositionOverlay myposOverlay = new PositionOverlay();
        myposOverlay.setUser(user);
        
	    final List<Overlay> overlays = mapView.getOverlays();	   
	    overlays.add( myposOverlay );
	    
	    mapView.setClickable(true);
        
    }
    
    @Override
    protected Dialog onCreateDialog(int id) {
        
    	switch (id) {
	    	case DIALOG_UPDATE_STATE:
	    		
	    		LayoutInflater factory = LayoutInflater.from(this);
	    		final View textEntryView = factory.inflate(R.layout.state, null);
	    		
	    		final EditText edit = (EditText) textEntryView.findViewById (R.id.txtstate);
	    		edit.setText("");
	    		
		        return new AlertDialog.Builder(this)	        
		        .setTitle("Update state")
		        .setView(textEntryView)
		        .setPositiveButton("update", new DialogInterface.OnClickListener() {
		            public void onClick(DialogInterface dialog, int whichButton) {
		
		            	if ( LibreGeoSocial.getInstance().setStatus(edit.getText().toString()))
		            	{		            		
		            		txtState.setText(edit.getText().toString());
		            	}
		            	else
		            	{
		            		Toast.makeText(getBaseContext(), 
			     					   "Error while the status was setted: " + 
			     					   LibreGeoSocial.getInstance().getLastMsgServer(), 
			     					   Toast.LENGTH_LONG).show();
		            	}
		            	
		                /* User clicked OK so do some stuff */
		            }
		        })
		        .setNegativeButton("cancel", new DialogInterface.OnClickListener() {
		            public void onClick(DialogInterface dialog, int whichButton) {
		
		                /* User clicked cancel so do some stuff */
		            }
		        })
		        .create();
	
	    	
	    }
    	
    	return null;
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	
        super.onCreateOptionsMenu(menu);
        menu.add(0, MENU_RESOURCES, 0, "Around Places")
        		.setIcon(R.drawable.register)
                .setAlphabeticShortcut('A');
        
        menu.add(0, MENU_STATE, 0 , "Update State")
        		.setIcon(R.drawable.refresh_48)
                .setAlphabeticShortcut('B');
        
        SubMenu sub = menu.addSubMenu (0, MENU_LOCATION, 0 , "Location")
        			  .setIcon(R.drawable.mundo);
        
        sub.add(0,MENU_LOCATION_GPS,0, "GPS");
        sub.add(0,MENU_LOCATION_WIFI,0, "WIFI");
        
        
        return true;
    }

    @Override
    public boolean onOptionsItemSelected (MenuItem item) {
    	
    	switch (item.getItemId()) {
    	
    	case MENU_RESOURCES:
        	
    		ResourceManager.getInstance().reset();
    		Intent i = new Intent(this,ResourceTab.class);
        	startActivity(i); 
        	
    		break;

    	case MENU_STATE:
    		
    		showDialog(DIALOG_UPDATE_STATE);
    		
    		break;
    		
    	case MENU_LOCATION_GPS:
    
    		LocationType = LocationManager.GPS_PROVIDER;
    		
    		break;
    		
    	case MENU_LOCATION_WIFI:
    
    		LocationType = LocationManager.NETWORK_PROVIDER;
    		
    		break;
    		
        }
        return super.onOptionsItemSelected(item);
    }
    
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	} 
	
	public void run() {
    	
		mLocationManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
		
		if (mLocationManager.isProviderEnabled(LocationManager.GPS_PROVIDER)) {
			
			Looper.prepare();
			
			mLocationListener = new MyLocationListener();
			
			mLocationManager.requestLocationUpdates(
					LocationType, 0, 0, mLocationListener);
			Looper.loop(); 
			Looper.myLooper().quit(); 
			
		} else {
			
			
            Toast.makeText(getBaseContext(), 
                    getResources().getString(R.string.gps_signal_not_found), 
                    Toast.LENGTH_LONG).show();
            
		}
	}
	
	
    
	private Handler handler = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			pd.dismiss();
			mLocationManager.removeUpdates(mLocationListener);
	    	if (currentLocation!=null) {
	    		//outlat.setText("Latitude: " + currentLocation.getLatitude());
	    		//outlong.setText("Longitude: " + currentLocation.getLongitude());
	    	}
		}
	};
	
    
    private class MyLocationListener implements LocationListener 
    {

        public void onLocationChanged(Location loc) {
            if (loc != null) {
                Toast.makeText(getBaseContext(), 
                    getResources().getString(R.string.gps_signal_found), 
                    Toast.LENGTH_LONG).show();
                setCurrentLocation(loc);
                showMap();
                handler.sendEmptyMessage(0);
            }
        }


        public void onProviderDisabled(String provider) {
            // TODO Auto-generated method stub
        }


        public void onProviderEnabled(String provider) {
            // TODO Auto-generated method stub
        }


        public void onStatusChanged(String provider, int status, 
            Bundle extras) {
            // TODO Auto-generated method stub
        }
    }



    
}

