/*
 *
 *  Copyright (C) 2008 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */


package com.LibreGeoSocialApp;

import com.LibreGeoSocial.Api.LibreGeoSocial;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class LibreGeoSocialApp extends Activity implements OnClickListener {
	
	private static final String TAG 		= "LibreGeoSocialApp";
	
    private static final int MENU_REGISTER = Menu.FIRST + 1;
    private static final int MENU_ABOUT = Menu.FIRST + 2;

    ImageView imgLS;
	Button btLogin;
	Button btRegister;
	
	TextView txtUser;
	TextView txtPasswd;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.login);
        
        txtUser = (TextView) this.findViewById(R.id.txtLogin);
        txtPasswd = (TextView) this.findViewById(R.id.txtPass);
        
        btLogin = (Button)this.findViewById(R.id.btLogin); 
        btLogin.setOnClickListener(this);
        
        btRegister = (Button)this.findViewById(R.id.btRegister); 
        btRegister.setOnClickListener(this);

        imgLS = (ImageView)this.findViewById(R.id.imgLS);
        imgLS.setImageResource(R.drawable.libresoft);              

        LibreGeoSocial.getInstance().setUrl("http://193.147.51.135/social/");
        LibreGeoSocial.getInstance().setFormat("JSON");
        
    }
    
    
    public void onClick(View v) { 
        
        if ( btLogin.isPressed() )
        {
	    	boolean login = LibreGeoSocial.getInstance().login( txtUser.getText().toString(), 
	    														txtPasswd.getText().toString());
	    	    	
	
	    	if (login)
	    	{
	    		Intent i = new Intent(this,GeoSocialTab.class);
	    		startActivity(i); 
	    	}
	    	else
	    	{
	    	
	    		Toast.makeText(getBaseContext(), 
	    					   "Error: " + LibreGeoSocial.getInstance().getLastMsgServer(), 
	    					   Toast.LENGTH_LONG).show();
	    		
	    	}
        }
        else if (btRegister.isPressed())
        {        	
    		Intent i = new Intent(this,Register.class);
        	startActivity(i); 
        }
    	
    }
    	
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	
        super.onCreateOptionsMenu(menu);
        menu.add(0, MENU_REGISTER, 0, "Register")
        		.setIcon(R.drawable.register)
                .setAlphabeticShortcut('A');
        
        menu.add(0, MENU_ABOUT, 0, "About")
			    .setIcon(R.drawable.icon)
		        .setAlphabeticShortcut('B');        
        
        return true;
    }
    
    @Override
    public boolean onOptionsItemSelected (MenuItem item) {
    	
    	switch (item.getItemId()) {
    	
    	case MENU_REGISTER:
    		
    		Intent i = new Intent(this,Register.class);
        	startActivity(i); 
        	
    		break;
    		
        case MENU_ABOUT:
        	
            break;
        }
        return super.onOptionsItemSelected(item);
    }



}

