/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocialApp.Resources;

import java.util.ArrayList;

import android.graphics.Point;
import android.util.Log;

import com.google.android.maps.GeoPoint;

public class ResourceItem {

	public static final int MILLION = 1000000;


	private String mTitle;
	private String mSummary;
	private String mDate;
	private Double mLatitude;
	private Double mLongitude;
	private String mUrl;
	private String mService;
	
	private ArrayList<String> mKeywords;
	private Point mLocation = null;

	public ResourceItem () {
		super();
	}
	
	public ResourceItem(String title, String summary, String date,
			Double latitude, Double longitude, String url, String service,
			ArrayList<String> keywords) {
		super();
		mTitle = title;
		
		if (summary==null)
			mSummary = "Without Description.";
		else
			mSummary = summary;
		
		mDate = date;
		mLatitude = latitude;
		mLongitude = longitude;
		mUrl = url;
		mService = service;
		mKeywords = keywords;
		
		mLocation = new Point (mLatitude.intValue(), mLongitude.intValue());

	}
	
	public String getTitle() {
		return mTitle;
	}
	public String getSummary() {
		return mSummary;
	}
	public String getDate() {
		return mDate;
	}
	public Double getLatitude() {
		return mLatitude;
	}
	public Double getLongitude() {
		return mLongitude;
	}
	public String getUrl() {
		return mUrl;
	}
	public String getService() {
		return mService;
	}
	public ArrayList<String> getKeywords() {
		return mKeywords;
	}
	
	public Point getLocation() {
		return mLocation;
	}
	
	
	

	
}
