/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocialApp.Resources;

import java.util.ArrayList;

public class ResourceManager 
{
	public static final String PHOTO_RESOURCE  	= "panoramio";
	public static final String VIDEO_RESOURCE  	= "YOUTUBE";
	public static final String PLACES_RESOURCE 	= "11870";
	public static final String ALL_RESOURCE 	= "ALL";
	
	static private ResourceManager singleton = null;
	
	private ArrayList<ResourceItem> mPhotosResurce = new ArrayList<ResourceItem>();
	private ArrayList<ResourceItem> mVideosResource = new ArrayList<ResourceItem>();
	private ArrayList<ResourceItem> mPlacesResource = new ArrayList<ResourceItem>();
	
	static public ResourceManager getInstance() 
	{
        if (singleton == null) {
            singleton = new ResourceManager();
        }
        return singleton;
		
	}
	
	public void addResource (ResourceItem item, String resource)
	{
		getList(resource).add(item);	
	}
	
	public ResourceItem getResource (Integer position, String resource)
	{
		return getList(resource).get(position);
	}
		
	public Integer getSize(String resource)
	{
		return getList(resource).size();
	}
	
	public void reset()
	{
		mPhotosResurce.clear();
		mVideosResource.clear();
		mPlacesResource.clear();
	}

	private ArrayList<ResourceItem> getList (String resource)
	{
		
		if (resource.equals(PHOTO_RESOURCE))
			return mPhotosResurce;		
		else if (resource.equals(VIDEO_RESOURCE))
			return mVideosResource;
		
		else if (resource.equals(PLACES_RESOURCE))
			return mPlacesResource;
		else
			return null;
	}
}