/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocialApp;

import java.util.List;

import android.content.Intent;
import android.os.Bundle;
import android.widget.ImageView;
import android.widget.TextView;

import com.LibreGeoSocial.Api.LibreGeoSocial;
import com.LibreGeoSocial.Api.User;
import com.LibreGeoSocialApp.Overlay.PositionOverlay;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;

public class UserCard extends MapActivity {

	
	private ImageView imageUser;
	private TextView txtUserName;
	private TextView txtState;

	private MapView mapView;
	private User user;
	
    public void onCreate(Bundle icicle) {
    	
         super.onCreate(icicle);
        
         setContentView(R.layout.user_card);
         
         imageUser = (ImageView)this.findViewById(R.id.imgUser);
         imageUser.setImageResource(R.drawable.user_48);

         txtUserName = (TextView) this.findViewById(R.id.lbName);
         txtState = (TextView) this.findViewById(R.id.lbState);         
                 
         Intent i = getIntent();
         
         Integer userId  = i.getIntExtra ("userId", Integer.MIN_VALUE);
         
         user = LibreGeoSocial.getInstance().getInfoUser(true, userId);
         
         txtUserName.setText (user.getName());
         txtState.setText(user.getState());  
         
         
         showMap();
        
    }

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
    private void showMap()
    {
    	
        mapView = (MapView) findViewById(R.id.myMapView);
    	 
    	//mapView = new MapView(this, "0Tp7WsIDiyqp_gJLEiO55RXtkz7VsxOjQvL44SA");
        MapController mapControl = mapView.getController();
        
        
        GeoPoint geoPoint = new GeoPoint(  (int) (user.getLatitude() * 1000000), 
        						  		   (int) (user.getLongitude() * 1000000));
        mapControl.setZoom(20);
        mapControl.setCenter(geoPoint);
        
        PositionOverlay myposOverlay = new PositionOverlay();
        myposOverlay.setUser(user);
        
	    final List<Overlay> overlays = mapView.getOverlays();	   
	    overlays.add( myposOverlay );
	    
	    mapView.setClickable(true);
        
    }
}
