/*
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */


package com.LibreGeoSocial.Api;

import java.util.Comparator;

import com.LibreGeoSocialApp.Routes.LocationService;
import com.LibreGeoSocialApp.Utils.LocationUtils;

public class GeoNodePositionComparator implements Comparator<GeoNode>
{

	public int compare(GeoNode node1, GeoNode node2) {
		// TODO Auto-generated method stub
		
		float dist1 = LocationUtils.calculateDistance (LocationService.getCurrentLocation(), node1.getLocation());
		float dist2 = LocationUtils.calculateDistance (LocationService.getCurrentLocation(), node2.getLocation());
		
		if (dist1>dist2)
			return +1;
		else if (dist1<dist2)
			return -1;
		else
			return 0;
	}
	
	
}