/*
 *
 *  Copyright (C) 2008-2010 GSyC/LibreSoft, Universidad Rey Juan Carlos
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocial.Api.Layers;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;

import com.LibreGeoSocial.Api.GeoNode;
import com.LibreGeoSocial.Api.GeoNodePositionComparator;
import com.LibreGeoSocial.Api.LibreGeoSocial;

import android.os.Handler;
import android.util.Log;
 
public class LibreGeoSocialLayer extends GenericLayer implements Serializable 
{ 

	private static final long serialVersionUID = -6501648066678686473L;
	
	public LibreGeoSocialLayer(String name, Double distance, String pattern) {
		super(name, distance, pattern);
	}

	@Override
	public Thread getThreadtoUpdate(final Handler hNotification,  final String[] categories) 
	{
		final Integer elems = 5;
		
		Log.e("LibreGeoSocialLayer","getThreadtoUpdate");
		
		Thread th = new Thread()
		{
        	public void run()
        	{
        		ArrayList<GeoNode> auxArray = new ArrayList<GeoNode>();
        		
        		if (categories[0].equals("0"))
        			auxArray.addAll (LibreGeoSocial.getInstance().getLayerNodes (getNameLayer(), 
        																		 getPattern(), 
        																		 "person", 
        																		 getDistance(),
        																		 getCurrentPage(),
        																		 elems));
 
        		if (categories[1].equals("0"))
        			auxArray.addAll (LibreGeoSocial.getInstance().getLayerNodes (getNameLayer(), 	
        																		 getPattern(), 
        																		 "photo", 
        																		 getDistance(),
        																		 getCurrentPage(),
        																		 elems));

        		if (categories[2].equals("0"))
        			auxArray.addAll (LibreGeoSocial.getInstance().getLayerNodes (getNameLayer(), 
        																		 getPattern(), 
        																		 "note", 
        																		 getDistance(),
        																		 getCurrentPage(),
        																		 elems));

        		if (categories[3].equals("0"))
        			auxArray.addAll (LibreGeoSocial.getInstance().getLayerNodes (getNameLayer(), 
        																		 getPattern(), 
        																		 "sound", 
        																		 getDistance(),
        																		 getCurrentPage(),
        																		 elems));
        		
        		if (! auxArray.isEmpty() )
        		{
        			GeoNodePositionComparator comparator = new GeoNodePositionComparator();
        			Collections.sort(auxArray, comparator);
        		}
        		
        		mArrayNodes = auxArray;
        		
				hNotification.sendEmptyMessage(0);
        	}
		};
		  
		return th;
	}

	@Override
	public String[] getCategories() 
	{
		return new String[] {
	        "Friends", "Photos", "Notes", "Audio"
	    };
	}

}
