/*
 *
 *  Copyright (C) 2010 GSyC/LibreSoft, Universidad Rey Juan Carlos.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Raúl Román López <rroman@gsyc.es>
 *
 */

package com.LibreGeoSocialApp.AR.Overlays;

import com.LibreGeoSocialApp.AR.ARUtils;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.RectF;
import android.view.View;


public class DrawArrow extends View{

	private float azimuth;
	private Context mContext;
	
	public DrawArrow(Context context) {
		super(context);
		mContext = context;
		// TODO Auto-generated constructor stub
		azimuth = 0;
	}
	
	public void setAzimuth(float azimuth){
		this.azimuth = azimuth;
		
	}
	
	
	@Override
	protected void onDraw(Canvas canvas){
		
		int w = canvas.getWidth();
        int h = canvas.getHeight();
        float cx = (w) / 2  + ARUtils.transformPixInDip(mContext, 180);
        float cy = (h) / 2 + ARUtils.transformPixInDip(mContext, 75);
		Paint paint = new Paint();
		paint.setStyle(Paint.Style.FILL);
		paint.setARGB(250, 245, 255, 245);
		
        RectF oval = new RectF(cx - 50, cy - 50, cx + 50, cy + 50);

		canvas.rotate(azimuth, cx, cy);
		canvas.drawArc(oval, 270-DrawResource.MAX_AZIMUTH_VISIBLE, 
				DrawResource.MAX_AZIMUTH_VISIBLE*2, true, paint);
		
		super.onDraw(canvas);
	}
}