/*
 *
 *  Copyright (C) 2010 GSyC/LibreSoft, Universidad Rey Juan Carlos
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@libresoft.es>
 *
 */

package com.LibreGeoSocialApp.AlarmManager;

import java.io.Serializable;
import java.util.ArrayList;

import android.location.Location;

import com.LibreGeoSocial.Api.GeoNode;

public abstract class GenericAlarm implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6650042683017287017L;
	private String mPattern;
	private String mName;
	private boolean mSemanticSearchActive;
	
	
	private static ArrayList<GeoNode> mNodeList;
	
	public GenericAlarm (String name)
	{
		mSemanticSearchActive = false;
		mPattern = null;
		mName = name;
	}
	
	public void setSearchPattern (String pattern)
	{
		pattern = mPattern;
	}
	
	public String getSearchPatter ()
	{
		return mPattern;
	}
	
	public String getName()
	{
		return mName;
	}
	
	public void activeSemanticSearch ()
	{
		mSemanticSearchActive = true;
	}

	
	/// \brief This method generate all the information and save it 
	///		   in GeoNode Array 'mNodeList'
	public abstract ArrayList<GeoNode> refreshData (Location CurrentLocation);
	
	
}
