/*
 *
 *  Copyright (C) 2008-2010 GSyC/LibreSoft, Universidad Rey Juan Carlos
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocialApp;

import android.app.TabActivity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.TabHost;

import com.LibreGeoSocialApp.AlarmManager.AlarmList;

public class GeoSocialTab extends TabActivity {

	@Override
    protected void onCreate(Bundle savedInstanceState) {
     
		super.onCreate(savedInstanceState);
		
		final TabHost tabHost = getTabHost();
		
		tabHost.addTab(tabHost.newTabSpec("Home")
                .setIndicator("Home", this.getResources().getDrawable(R.drawable.home_38))          
                .setContent(new Intent(this, Home.class)));
		
		tabHost.addTab(tabHost.newTabSpec("Layers")
                .setIndicator("Layers", this.getResources().getDrawable(R.drawable.layer))
                .setContent(new Intent(this, LayerList.class)));
		
		tabHost.addTab(tabHost.newTabSpec("Friends")				
                .setIndicator("Friends", this.getResources().getDrawable(R.drawable.users_two_38))
                .setContent(new Intent(this, FriendList.class)));
		
		tabHost.addTab(tabHost.newTabSpec("Alarms")
                .setIndicator("Alarms", this.getResources().getDrawable(R.drawable.alarm))
                .setContent(new Intent(this, AlarmList.class)));		
		
		
		tabHost.computeScroll(); 
	}
}