/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Jorge Fernandez Gonzalez <jorge.fernandez.gonzalez@gmail.com>
 *
 */

package com.LibreGeoSocialApp.Gymkhana;

import android.app.TabActivity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.TabHost;

import com.LibreGeoSocialApp.R;

/**
 * Crea un tab en el que poder elegir entre tres posibles actividades (presentación de
 * la prueba en curso, mapa de localización del equipo y sistema de mensajería).
 * 
 * @author Jorge Fernandez Gonzalez <jorge.fernandez.gonzalez@gmail.com>
 * 
 */
public class Competition extends TabActivity{
	/* El usuario puede pulsar accidentalmente el botón hardware de la flecha para
	 * ir hacia una pantalla anterior, saliéndose de la aplicación; para controlar esto,
	 * la variable FINISH_SW almacenará si la finalización de una Activity se ha
	 * indicado desde el propio flujo de la aplicación, por software (true), o si se
	 * debe al botón del móvil (hardware, false).
	 */
	public static boolean FINISH_SW = false;
	
	@Override
    protected void onCreate(Bundle savedInstanceState) {
     
		super.onCreate(savedInstanceState);
		
		final TabHost tabHost = getTabHost();
		
		tabHost.addTab(tabHost.newTabSpec("Proof")
                .setIndicator("Challenge", this.getResources().getDrawable(R.drawable.gymkhana))
                .setContent(new Intent(this, Proof.class)));
		
		tabHost.addTab(tabHost.newTabSpec("TeamLocationMap")				
                .setIndicator("Location", this.getResources().getDrawable(R.drawable.mundo))
                .setContent(new Intent(this, TeamLocationMap.class)));
		
		tabHost.addTab(tabHost.newTabSpec("Messaging")				
                .setIndicator("Messaging", this.getResources().getDrawable(R.drawable.message))
                .setContent(new Intent(this, Messaging.class)));
	
		tabHost.computeScroll();

		FINISH_SW = false;
	}
}