/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Jorge Fernandez Gonzalez <jorge.fernandez.gonzalez@gmail.com>
 *
 */

package com.LibreGeoSocialApp.Gymkhana;

/**
 * Representa cada evento o gymkhana disponible en el sistema.
 * 
 * @author Jorge Fernandez Gonzalez <jorge.fernandez.gonzalez@gmail.com>
 * 
 */
public class Event{
	
	/* Identificador del evento o gymkhana. */
	private int identifier;
	/* Nombre o título de la gymkhana. */
  	private String title;
  	/* Fecha de celebración (String para trabajar más cómodamente). */
   	private String celebration;
   	/* Lugar de celebración del evento. */
   	private String place;
   	/* Texto de bienvenida a la gymkhana que se presentará en la aplicación. */
   	private String welcomeText;
   	/* Texto de despedida que se presentará en la aplicación. */
   	private String goodbyeText;
   	/* El organizador de la gymkhana. */
   	private Manager manager;
    	
   	public Event(int identifier, String title, String celebration, String place,
   				String welcomeText, String goodbyeText, Manager manager){
   		
   		this.identifier = identifier;
   		this.title = title;
   		this.celebration = celebration;
   		this.place = place;
   		this.welcomeText = welcomeText;
   		this.goodbyeText = goodbyeText;
   		this.manager = manager;
   	}
    
   	public int getIdentifier(){
   		return identifier;
   	}
   	
   	public String getTitle(){
   		return title;
   	}
   	
   	public String getCelebration(){
   		return celebration;
   	}
   	
   	public String getPlace(){
   		return place;
   	}
   	
   	public String getWelcomeText(){
   		return welcomeText;
   	}
   	
   	public String getGoodbyeText(){
   		return goodbyeText;
   	}
   	
   	public Manager getManager(){
   		return manager;
   	}
   	
   	public static Event findById(Event events[], int id){
   		Event event = null;
   		for (int i = 0; i < events.length-1; i++){
   			if (events[i].getIdentifier() == id)
   				event = events[i];
   		}
   		return event;
   	}
   	
}