package com.LibreGeoSocialApp.Gymkhana;

import com.LibreGeoSocial.Api.LibreGeoSocial;
import com.LibreGeoSocialApp.Home;

import android.app.Service;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.IBinder;
import android.util.Log;

/**
 * LocationListener ligero para uso exclusivamente en la aplicación de Gymkhanas
 * dentro de LibreGeoSocialApp.
 * 
 * @author Jorge Fernandez Gonzalez <jorge.fernandez.gonzalez@gmail.com>
 * 
 */
public class GymkhanaLocationListener extends Service implements LocationListener, Runnable {

	private static final String LOCATION_SERVICE = null;
	private LocationManager locationManager;
	private Location location;
	
	@Override
	public void onCreate() {
		// Set up the LocationManager
		Log.d("GymkhanaLocationListener", "onCreate()-1");
		locationManager = (LocationManager)getSystemService(android.content.Context.LOCATION_SERVICE);
		// Configuro el GPS cada 5 segundos y cada 5 metros.
		locationManager.requestLocationUpdates(
			LocationManager.GPS_PROVIDER, 
			5000, 
			5, 
			this
		);
	}

	@Override
	public void onDestroy() {
		if (locationManager != null)
			locationManager.removeUpdates(this);
	}

	/**********************************************************************
	 * LocationListener overrides below 
	 **********************************************************************/
	@Override
	public void onLocationChanged(Location location) {
		// We got new location info.
		//TeamList.team.setLocation(location);
		Home.currentLocation.setAltitude((float)location.getAltitude());
		Home.currentLocation.setLatitude(location.getLatitude());
		Home.currentLocation.setLongitude(location.getLongitude());
		//sendLocation();
		this.location = location;
		// Envío la nueva posición al servidor de LibreGeoSocial en un hilo nuevo
		// para que no cuelgue al resto de la aplicación Android.
		Thread thread = new Thread(this);
        thread.start();
	}

	@Override
	public void onProviderDisabled(String provider) {}    

	@Override
	public void onProviderEnabled(String provider) {}    

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {}
 
	public void run(){
		LibreGeoSocial.getInstance().setUserPosition (location.getLatitude(), 
													  location.getLongitude(),
													  location.getAltitude());
	}

	@Override
	public IBinder onBind(Intent intent) {
		// TODO Auto-generated method stub
		return null;
	}
}