/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Jorge Fernandez Gonzalez <jorge.fernandez.gonzalez@gmail.com>
 *
 */

package com.LibreGeoSocialApp.Gymkhana;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
/*import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;*/
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

import com.LibreGeoSocial.Api.LibreGeoSocial;
import com.LibreGeoSocialApp.Home;
import com.LibreGeoSocialApp.R;
import com.LibreGeoSocialApp.Routes.LocationService;

/**
 * Presenta al usuario textos informativos, ya sean de bienvenida a la gymkhana o
 * de finalización de la misma.
 * 
 * @author Jorge Fernandez Gonzalez <jorge.fernandez.gonzalez@gmail.com>
 * 
 */
public class InformativeText extends Activity implements OnClickListener/*, LocationListener, Runnable*/ {
	/* TAG for log messages*/
	static private String TAG = "InformativeText";

	/*private LocationManager locationManager;
	private Location location;*/

	/* Message from last petition */
	private String lastMsg = null;

	/* Code from last petition */
	private Integer lastCode = 0;

	private String lastInformativeText = null;

	private TextView textInformativeText;
	private Button buttonContinue;
	private TextView textResumeGymkhana;

	private int lastNumCorrectResponses = 0;
	private int lastNumIncorrectResponses = 0;

	public static boolean exit = false;
	public static String reasonToExit = null;

	protected Dialog onCreateDialog(int id){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setMessage(reasonToExit)
		       .setCancelable(false)
		       .setPositiveButton("Exit", new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		                InformativeText.this.finish();
		           }
		       });
		AlertDialog alert = builder.create();
		return alert;
	}

    public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    
	    if (exit){
	    	showDialog(1);
	    }else{
	    	DefaultHttpClient httpclient = new DefaultHttpClient();
	    	try{
	    		String param = null;
        	
	    		if (Proof.lastIsLastProof == true){
	    			param = "?information=finish_gymkhana&format=json";
	    		}else{
	    			param = "?information=start_gymkhana&format=json";
    				showInformationDialog();
	    		}
        	
	    		URI uri = new URI(Gymkhana.urlServer + "gymkhana/event/" + Integer.toString(EventList.event.getIdentifier()) + "/team/" + Integer.toString(TeamList.team.getIdentifier()) + "/information_gymkhana/" + param);
	    		HttpGet httget = new HttpGet(uri);
				LibreGeoSocial LGS = LibreGeoSocial.getInstance();
				httpclient.setCookieStore(LGS.getCookieStore());
	    		HttpResponse response = httpclient.execute(httget);
	    		HttpEntity entity = response.getEntity();
	    		String str = convertStreamToString(entity.getContent());
	    		processMessageResponse(str);
	    		setContentView(R.layout.informative_text);
            
	    		textInformativeText = (TextView) this.findViewById(R.id.textInformativeText);
	    		buttonContinue = (Button) this.findViewById(R.id.buttonContinue);
	    		textResumeGymkhana = (TextView) this.findViewById(R.id.textResumeGymkhana);
	    		textInformativeText.setText(lastInformativeText);
	    		if (param.contains("finish_gymkhana")){
	    			buttonContinue.setText("Finish Gymkhana");
	    			textResumeGymkhana.setText("Tentatively: You Has Passed " + lastNumCorrectResponses + " Challenges With " + lastNumIncorrectResponses + " Incorrect Responses");
	    		}else{
	    			buttonContinue.setText("Start Gymkhana!");
	    		}
	    		buttonContinue.setOnClickListener(this);
            
	    		// Activo el listener para la geolocalización del equipo:
	    		//startListening();
	    	}catch(URISyntaxException urisex){
	    		Log.e(TAG, urisex.getMessage());
	    	}catch (IOException e) {
	    		// TODO Auto-generated catch block
	    		Log.e(TAG,e.getMessage());
	    	}
	    }
    } 
    
    public void onClick(View v) { 
        if ( buttonContinue.isPressed() ){
        	if (!Proof.lastIsLastProof){
        	    Intent i = new Intent(InformativeText.this,Competition.class);
                InformativeText.this.startActivity(i);
                this.setResult(RESULT_OK);
        		this.finish();
        	}else{
        		this.setResult(RESULT_OK);
        		Proof.lastIsLastProof = false;
        		exit = false;
        		reasonToExit = null;
        		
        		Intent messagingService = new Intent(this, MessagingService.class);
    	        this.stopService(messagingService);
    	        MessagingService.MESSAGING_SERVICE_ENABLED = false;
    	        Intent gymkhanaLocationService = new Intent(this, GymkhanaLocationListener.class);
    	        this.stopService(gymkhanaLocationService);
    	        Intent locationService = new Intent(this, LocationService.class);
    	        startService(locationService);
    	        
        		this.setResult(RESULT_OK);
        		this.finish();
        	}
        }
    }     	
    
    private String convertStreamToString (InputStream is) {
        BufferedReader reader = new BufferedReader(new InputStreamReader(is), 8*1024);
        StringBuilder sb = new StringBuilder();
 
        String line = null;
        try {
            while ((line = reader.readLine()) != null) {
                sb.append(line + "\n");
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                is.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return sb.toString();
    }
    
    private boolean processMessageResponse (String str) {
		
        try {
        	JSONObject json;
			json = new JSONObject(str);

			if (json.has("code"))
				lastCode = json.getInt("code");
			else
				lastCode = -1;
			
			if (json.has("description"))
				lastMsg = json.getString("description");
			else
				lastMsg = null;
			
			if (json.has("informative_text")){
				lastInformativeText = json.getString("informative_text");
			}else{
				return false;
			}

			if (json.has("num_correct_responses")){
				lastNumCorrectResponses = json.getInt("num_correct_responses");
			}
			if (json.has("num_incorrect_responses")){
				lastNumIncorrectResponses = json.getInt("num_incorrect_responses");
			}
			
			if (lastCode != 200)
				return false;
			
		} catch (JSONException e) {	
			lastCode = 500;
			lastMsg = "Error in json parsed: " + e.getMessage();
			Log.e(TAG, e.toString());
			return false;
		}
		
		return true;
	}
	
	private void showInformationDialog(){
    	AlertDialog.Builder builder = new AlertDialog.Builder(this);
    	String text = "Como indicaciones generales tanto al uso del teléfono móvil como "
    				+ "de la propia aplicación para la gymkhana, podemos decirte que:\n\n"
    				+ "El uso de las diversas funcionalidades y servicios se realizará "
    				+ "fundamentalmente a través de la pantalla táctil.\n\n"
    				+ "Será fundamental que en cada nueva pantalla pulses sobre el botón "
    				+ "\"MENU\" del teléfono móvil, pues te aparecerán nuevas opciones que "
    				+ "podrás seleccionar y que te podrán servir para la consecución de "
    				+ "cada nuevo reto o incluso instrucciones de uso específicas de cada "
    				+ "nueva pantalla en concreto.\n\n"
    				+ "Para introducir tu respuesta a cada prueba lo podrás hacer pulsando "
    				+ "sobre el cuadro de texto reservado para dicha respuesta y escribiéndola "
    				+ "por medio del teclado QWERTY si tu teléfono móvil cuenta con uno, o "
    				+ "con el teclado virtual que se desplegará sobre la pantalla táctil.\n\n"
    				+ "Ten en cuenta que podrás hacer scroll sobre la pantalla para leer el "
    				+ "resto del texto en caso de ser muy extenso, con tan sólo deslizar "
    				+ "el dedo hacia arriba y hacia abajo en la propia pantalla táctil.\n\n"
    				+ "Siempre que desees retroceder hacia una pantalla anterior dentro "
    				+ "de la aplicación (al igual que para retirar de la pantalla el teclado "
    				+ "virtual), hazlo pulsando sobre el botón con la flecha indicando hacia "
    				+ "atrás.\n\n"
    				+ "Si para la resolución de algún reto, crees necesario utilizar alguna otra "
    				+ "aplicación del móvil (por ejemplo, la calculadora), deberás salir de la "
    				+ "aplicación para la gymkhana pulsando sobre el botón con una casa como icono. "
    				+ "Cuando termines, para regresar a la aplicación de la gymkhana en el mismo "
    				+ "punto donde lo dejaste, tan sólo deberás seleccionar la aplicación llamada "
    				+ "\"LibreGeoSocial\".\n\n"
    				+ "En la barra de estado (parte superior de la pantalla) te aparecerán las "
    				+ "notificaciones del móvil como por ejemplo la recepción de un nuevo mensaje "
    				+ "de la aplicación para gymkhanas. Para desplegar esas notificaciones sólo "
    				+ "deberás arrastrar hacia abajo la barra de estado y pulsar sobre la "
    				+ "notificación que te interese o borrarlas todas.\n\n"
    				+ "Nunca pulses el resto de botones del teléfono móvil, pues podría "
    				+ "finalizar la ejecución de la aplicación y con ello saldrías de la "
    				+ "participación en la gymkhana.";
    	builder.setMessage(text)
    	       .setCancelable(false)
    	       .setPositiveButton("OK", new DialogInterface.OnClickListener() {
    	           public void onClick(DialogInterface dialog, int id) {
    	        	   dialog.cancel();
    	           }
    	       });
    	AlertDialog alert = builder.create();
    	alert.setTitle("Instructions");
    	alert.setIcon(R.drawable.info);
    	alert.show();
    }
}