/*
 *
 *  Copyright (C) 2008 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocialApp;

import java.util.ArrayList;

import android.app.TabActivity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.TabHost;

import com.LibreGeoSocial.Api.GeoNode;
import com.LibreGeoSocial.Api.LibreGeoSocial;
import com.LibreGeoSocial.Api.Layers._11870Layer;
import com.LibreGeoSocialApp.Resources.ResourceLGS;

public class ResourceTab extends TabActivity {

	@Override
    protected void onCreate(Bundle savedInstanceState) {
     
		super.onCreate(savedInstanceState);
		
		final TabHost tabHost = getTabHost();
		

		tabHost.addTab(tabHost.newTabSpec("LGS")
                .setIndicator("lgs",this.getResources().getDrawable(R.drawable.icon))             
                .setContent(new Intent(this, ResourceLGS.class)));	
		
		Intent Intent11870 = new Intent(this, NodeList.class);
		_11870Layer layer = new _11870Layer("11870",1000.0,"");

		Intent11870.putExtra ("layer",layer);

		tabHost.addTab(tabHost.newTabSpec("Places")
                .setIndicator("places",this.getResources().getDrawable(R.drawable.place_48))             
                .setContent(Intent11870));
		
		tabHost.addTab(tabHost.newTabSpec("Photos")				
                .setIndicator("photos", this.getResources().getDrawable(R.drawable.camera_38))
                .setContent(new Intent(this, PhotoList.class)));
		
		//tabHost.addTab(tabHost.newTabSpec("Videos")
        //        .setIndicator("videos")
        //        .setContent(new Intent(this, PhotoList.class)));
	
	}
}
