/*
 *
 *  Copyright (C) 2009 GSyC/LibreSoft
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/. 
 *
 *  Author : Roberto Calvo Palomino <rocapal@gsyc.es>
 *
 */

package com.LibreGeoSocialApp.Resources;

import java.util.ArrayList;

import android.graphics.Bitmap;

import com.LibreGeoSocialApp.Utils.BitmapUtils;

public class PanoramioItem extends ResourceItem {

	
	private String 	mOwner; 
	private Bitmap 	mBitmapImage;
	private Bitmap  mBitmapThumb;
	private String  mUrlImage;
	private String  mUrlThumb;
	
	
	public PanoramioItem () {
		super();
	}
	
	public PanoramioItem (String title, String summary, String date,
			Double latitude, Double longitude, Double altitude, String url, String service,
			ArrayList<String> keywords) {
		super(title, summary, date, latitude, longitude, altitude, url, service, keywords);
	}

	
	public PanoramioItem (String title, String summary, String date,
			Double latitude, Double longitude, Double altitude, String url, String service,
			ArrayList<String> keywords, String owner, String urlImage, String urlThumb) {
	
		super(title, summary, date, latitude, longitude, altitude, url, service, keywords);
		
		mOwner = owner;
		mUrlImage = urlImage;
		mUrlThumb = urlThumb;
		
		mBitmapImage = BitmapUtils.loadBitmap(mUrlImage);
		mBitmapThumb = BitmapUtils.loadBitmap(mUrlThumb);
		
	}
	

	public String getOwner() {
		return mOwner;
	}

	public Bitmap getBitmapImage() {
		return mBitmapImage;
	}
	
	public Bitmap getBitmapThumb() {
		return mBitmapThumb;
	}
	
	
}
