/*
 * 
 * Copyright and License
 * 
 * CC-GNU LGPL Developed by Daniel Winterstein, partially whilst at a previous company. 
 * This code is copyright (c) Winterwell Associates Ltd, 2008 and ThinkTank Mathematics Ltd, 2007, 
 * except where otherwise stated. It is released as open-source under the LGPL license. 
 * This code comes with no warranty or support.
 *
 * You must let your users know that you are using the JTwitter library, which they can get the 
 * source code for. A credit on your home page with a link-back to this page, e.g. built using JTwitter, 
 * is the recommended way to do this. Your own code can be licensed commercially and you do not have 
 * to release the source code.
 * 
 * More information: http://www.winterwell.com/software/jtwitter.php
 * 
 */

package com.winterwell.jtwitter;



/**
 * A runtime exception for when Twitter requests don't work. All
 * {@link Twitter} methods can throw this.
 * <p>
 * I believe unchecked exceptions are preferable to checked ones,
 * because they avoid the problems caused by swallowing exceptions.
 * But if you don't like runtime exceptions, just edit this class.
 *
 * @author Daniel Winterstein
 */
public class TwitterException extends RuntimeException {

	/**
	 * Wrap an exception as a TwitterException.
	 */
	TwitterException(Exception e) {
		super(e);
	}

	/**
	 * @param string
	 */
	public TwitterException(String string) {
		super(string);
	}

}
