#!/bin/bash

# Copyright 2009 (c) GSyC/LibreSoft
# This source is under GPL v3.0
#
# Roberto Cavo <rocapal@libresoft.es>

# 
# This script download the trunk of project and compile it.

WORK_DIR="/home/rocapal/trunk/"
SDK_DIR_1_6="/home/rocapal/android-sdk-linux/"
SDK_DIR_1_1="/home/rocapal/android-sdk-linux_x86-1.1_r1"

LOG_DIR="/home/rocapal/log/"

# init the environment
rm -rf $WORK_DIR

# Download trunk
svn co https://svn.forge.morfeo-project.org/libregeosocial/LibreGeoSocialApp/trunk ${WORK_DIR}&> /dev/null

# get and replace the revision
cd ${WORK_DIR}

mkdir -p ${LOG_DIR}

REVISION=`LANG=en_US svn info | grep ^Revision: | cut -d: -f2 | cut -c2-`

cat ${WORK_DIR}/src/com/LibreGeoSocialApp/res/values/strings.xml | sed -e s/\$REVISION/${REVISION}/ > /tmp/strings.xml
mv /tmp/strings.xml ${WORK_DIR}/src/com/LibreGeoSocialApp/res/values/strings.xml

#######
# 1.6 #
#######

echo "Compiling with SDK 1.6 ..."

# generate build.xml
cd ${WORK_DIR}
${SDK_DIR_1_6}/tools/android update project --path ${WORK_DIR} --target 3 -n LibreGeoSocialApp

ant debug &> ${LOG_DIR}/ant-${REVISION}.log

if [ $? -ne 0 ]; then
	mail -s "Compilation Error [1.6]: LibreGeoSocial" social-network@gsyc.escet.urjc.es < ${LOG_DIR}/ant-${REVISION}.log
	echo "Error"
	exit
fi

mv bin/LibreGeoSocialApp-debug.apk bin/LibreGeoSocialApp-${REVISION}_1.6.apk
mv bin/LibreGeoSocialApp-${REVISION}_1.6.apk /var/www/releases/



